#include <dirent.h>
#include <stdio.h>
#include <string.h>
#include <stdlib.h>
#include <signal.h>
#include <sys/types.h>
#include <sys/wait.h>
#include <unistd.h>
#include <gtk/gtk.h>
#include <sys/stat.h>
#include <fcntl.h>
#include <pthread.h>
#include "gwifimeter.h"
#include "callback.h"
#include "docklet.h"
#include "des.h"
//#include <crypt.h>

pthread_mutex_t muteks1 = PTHREAD_MUTEX_INITIALIZER;

void winconcancel(GtkWidget *entry)
{
    pdata->prostan=1;
}
char * search(char * searchtagret,char * searchfirst,char * searchsecond)
{

                char *tagret = strstr(searchfirst,searchtagret);
                if (searchsecond != NULL&&tagret != NULL&&tagret>searchfirst&&tagret<searchsecond)
                {
                    return tagret;
                }
                if (searchsecond == NULL&&tagret != NULL&&searchfirst<tagret)
                {
                    return tagret;
                }
                return NULL;
}

char * readfunc(const char * func , const char * par1 ,const char * par2 ,int dec)
{
    pthread_mutex_lock(&muteks1);
    char *tab2 ,*tab3;
    char *tab4;
    int fd1[2],co;
    pid_t pid;
    pipe(fd1);
    pid = fork();
    if (pid == -1)
    {
        perror("fork");
        pthread_mutex_unlock(&muteks1);
        exit(-1);
    }
    else if (pid == 0)
    {
        close(fd1[0]);
        dup2(fd1[1],1);//zamykamy stdout i duplkujemy je na potoku
        dup2(fd1[1],2);//zamykamy stdout i duplkujemy je na potoku
        execlp(func,func,par1,par2,NULL);
        perror("execlp");
        //_exit(-1);
    }
    close(fd1[1]);
    tab3 = (char *) g_malloc(1);
    if (tab3==0)
        printf("virtual memory exceeded\n");
    *tab3='\0';
    tab2 = (char *) g_malloc(1);
    if (tab2==0)
        printf("virtual memory exceeded\n");
    *tab2='\0';
    while (1)
    {
        co=read(fd1[0],tab2=(char *) g_realloc(tab2,sizeof(tab2)+1),sizeof(tab2));
        if (co==0) {
            close(fd1[0]);
            tab4=tab3+strlen(tab3)-dec;
            *tab4='\0';
            g_free(tab2);
            usleep (100);
            pthread_mutex_unlock(&muteks1);
            return tab3 ;
        }
        strncat(tab3  = g_realloc(tab3,strlen(tab3)+sizeof(tab2)+1),tab2,co);
        bzero(tab2,sizeof(tab2));
    }
}
//=========================================================
void stanbar(GtkWidget *bar , gdouble stan , char *stantext)
{
    gdk_threads_enter();
    gtk_progress_bar_set_fraction(GTK_PROGRESS_BAR(bar),stan);
    gtk_progress_bar_set_text(GTK_PROGRESS_BAR(bar),stantext);
    gdk_flush ();
    gdk_threads_leave();
}
//********************************************************************************************
int des_encrypt(unsigned char *buffer, int len, char *deskey)
{
  int checksum = 0;
  int noPadBytes;
  char padBytes[7];
  char ivec[8];
  int i;
  unsigned char out64[9];
  memset(ivec,0,8);
  des_key_schedule ks1,ks2;
  if(!deskey) return len;
  noPadBytes = (8 - ((len - 1) % 8)) % 8;
  for(i = 0; i < noPadBytes; i++) buffer[len++] = padBytes[i];
  for(i = 2; i < len; i++) checksum ^= buffer[i];
  buffer[len++] = checksum;
  memcpy(buffer+len, ivec, 8);
  for(i = 2; i < len; i += 8)
    {
    des_set_key((des_cblock*)deskey,ks1);
    des_cbc_encrypt(buffer+i,out64, 8,ks1,(des_cblock *)ivec,DES_ENCRYPT);
    memcpy(buffer+i, out64, 8);
    des_set_key((des_cblock*)(deskey+8),ks2);
    des_ecb_encrypt((const_des_cblock *)(buffer+i),(des_cblock*)out64,ks2,DES_DECRYPT);
    memcpy(buffer+i, out64, 8);
    des_set_key((des_cblock*)deskey,ks1);
    des_ecb_encrypt((const_des_cblock *)(buffer+i),(des_cblock*)out64,ks1,DES_ENCRYPT);
    memcpy(buffer+i, out64, 8);
    memcpy(ivec, buffer+i, 8);
    }
  len += 8;
  return len;
}
int des_decrypt(unsigned char *buffer, int len, char *deskey)
{
  char ivec[8];
  char nextIvec[8];
  int i;
  char checksum = 0;


  if(!deskey) return len;
  if((len-2) % 8 || (len-2) < 16) return -1;
  len -= 8;
  memcpy(nextIvec, buffer+len, 8);

  for(i = 2; i < len; i += 8)
    {
    des_key_schedule ks1,ks2;
    memcpy(ivec, nextIvec, 8);
    memcpy(nextIvec, buffer+i, 8);
    unsigned char out64[9];

    des_set_key((des_cblock*)deskey, ks1);
    des_ecb_encrypt((const_des_cblock *)(buffer+i),(des_cblock*)out64, ks1,DES_DECRYPT);
    memcpy(buffer+i, out64, 8);

    des_set_key((des_cblock*)(deskey+8), ks2);
    des_ecb_encrypt((const_des_cblock *)(buffer+i),(des_cblock*)out64, ks2,DES_ENCRYPT);
    memcpy(buffer+i, out64, 8);

    des_set_key((des_cblock*)deskey, ks1);
    des_cbc_encrypt(buffer+i,out64,8,ks1,(des_cblock *)ivec,DES_DECRYPT);
    memcpy(buffer+i, out64, 8);
    }
  for(i = 2; i < len; i++) checksum ^= buffer[i];
  if(checksum) return -1;
  return len;
}

char *data2hex(unsigned char *start,int len)
{
  int len1=len;
  char *returnbuf = NULL;
  returnbuf = g_malloc(sizeof(char)*len * 2 + 5);
  returnbuf[0] = '\0';
  char tempbuf[3];
  unsigned char charbuf[1];
	int bufchar;
  while(len1--)
    {
		charbuf[0]=*start;
		bufchar=*start;
		//printf("%d=",bufchar);
		sprintf(tempbuf, "%02X", charbuf[0]);
		strcat(returnbuf, tempbuf);
		start++;
    }
	//printf("\n");
  return returnbuf;
}

unsigned char *hex2data(unsigned char *s, int *bytes)
{
  static unsigned char *returnbuf = NULL;
  unsigned char *c;
  int b;

  returnbuf = g_malloc(strlen((const char *)s) / 2 + 5);
  returnbuf[0] = '\0';
  for(b=0, c=s; *c; )
    {
      unsigned char hex[3];
      int i;
      hex[0] = *c++;
      hex[1] = *c++;
      hex[2] = '\0';
      if(!hex[1])       // invalid: ends halfway thru hex pair
	break;
      sscanf((const char *)hex, "%X", &i);
    }

  if(bytes)
    *bytes = b;

  return returnbuf;
}
unsigned char *hex2data2(unsigned char *s)
{
	int bytes=strlen((char *)s);
	if(bytes==0)return NULL;
	static unsigned char *returnbuf = NULL;
	unsigned char hex[3];
	int i,o=0;
	unsigned char *c;
	c=s;
  returnbuf = g_malloc(bytes / 2 + 1);
	memset(returnbuf,0,bytes / 2 + 1);
  while(bytes)
    {
      hex[0] = *c++;
      hex[1] = *c++;
      hex[2] = '\0';
      sscanf((const char *)hex, "%X", &i);
		returnbuf[o++]=i;
		//printf("%d-",i);
		bytes-=2;
		if(bytes<0)break;
    }
	//printf("\n");
  return returnbuf;
}
gchar * paread(gchar * crypt)
{
	//printf("crypt %s\n",crypt);
	char tmpkey[17];
	memset (tmpkey, 0, 17);
	memcpy (tmpkey, &pdata->user[0], 16);
	int len = strlen(crypt)/2;
	unsigned char * bincryp = hex2data2((unsigned char *)crypt);
	int returnLen = ((bincryp[0] << 8) | bincryp[1]);
	len = des_decrypt(bincryp, len, tmpkey);
	returnLen = (((bincryp[2] & 0x0f) << 8) | bincryp[3]) + 3;
	memcpy (bincryp, &bincryp[4],returnLen);
	bincryp[returnLen]='\0';
	return (gchar *)bincryp;
}
gchar * pasave(const gchar * pass)
{
	char tmpkey[17];
	memset (tmpkey, 0, 17);
	strncpy (tmpkey, &pdata->user[0], 16);
	char buf[255];
	memset (buf, 0, 255);
	strcpy(buf,"    ");
	strcpy(&buf[4],pass);
	int len = strlen(buf)-4;
	buf[2] = (buf[1] & 0xf0) | (((len - 3) >> 8) & 0x0f);
        buf[3] = (len - 3) & 0xff;
        len+=4;
	len = des_encrypt((unsigned char *)buf,len, tmpkey);
	buf[0] = (len - 2) >> 8;
	buf[1] = (len - 2) & 0xff;
	char * cryhex = data2hex((unsigned char *)buf,len);
	return cryhex;
}

//==========================================================================
void windevent(void)
{
    if (gtk_toggle_button_get_active (GTK_TOGGLE_BUTTON (pdata->checkbutton1)))gtk_widget_hide (pdata->window);
    else gtk_main_quit ();
}
//==========================================================================
void sigchld_handler(int num)
{
    sigset_t set, oldset;
    pid_t pid;
    int status, exitstatus;

    /* block other incoming SIGCHLD signals */
    sigemptyset(&set);
    sigaddset(&set, SIGCHLD);
    sigprocmask(SIG_BLOCK, &set, &oldset);

    /* wait for child */
    while ((pid = waitpid((pid_t)-1, &status, WNOHANG)) > 0)
    {
        if (WIFEXITED(status))
        {
            exitstatus = WEXITSTATUS(status);
        }
        else if (WIFSIGNALED(status))
        {
            exitstatus = WTERMSIG(status);
        }
        else if (WIFSTOPPED(status))
        {
            exitstatus = WSTOPSIG(status);
        }
        else
        {
        }
    }
    /* re-install the signal handler (some systems need this) */
    signal(SIGCHLD, sigchld_handler);
    /* and unblock it */
    sigemptyset(&set);
    sigaddset(&set, SIGCHLD);
    sigprocmask(SIG_UNBLOCK, &set, &oldset);
}
//==============================================================
void compresspaces(const char* S)
{
    char *s   = (char*)S;
    char prev = '1';

    while (*S)
    {
        if ((prev != ' ') || (*S != ' '))
            *s++ = *S;

        prev = *S++;
    }
    *s = '\0';
//return S;
}
//===============================================================
void space (char *dane)
{
    int a=1;
    while (1)
    {
        if (*(dane+a)==' ')
        {
            *(dane+a)='\0';
            break;
        }

        if (*(dane+a)=='\n')
        {
            *(dane+a)='\0';
            break;
        }

        ++a;
    }
}
//==============================================================
void space2 (char *dane)
{
    int a=1;
    while (1)
    {
        if (*(dane+a)=='\n'){*(dane+a)='\0';break;}
        ++a;
    }
}
int endline (char *dane)
{
    int a=1;
    while (1)
    {
        if (*(dane+a)=='\n'){return a;}
        ++a;
    }
}
//============================================================
void chekuser ( void)
{
    strcpy(pdata->user,getenv("HOME"));
    strcat(pdata->user,"/.gwifimeter");
}
//======================================================================
void checkface ( void)
{
    char string[50];
    char * find;
    FILE  *fd;
    int i=0;
    fd = fopen("/proc/net/wireless","r");

    if (fd == NULL )
    {
        printf("\n error opening /proc/net/wireless \n");
        strcpy(pdata->interface,"null");
        return;
    }
    while (1)
    {
        if (fgets(&string[0],49,fd)>0)
        {
            find=strstr(string,":");
            if (find!=NULL)
            {
                while (1){
                    *find = '\0';
                    if (*(&string[i])==' ') ++i;
                    else break;
                }
                strcpy(pdata->interface,&string[i]);
                fclose(fd);
                break;
            }
        }
    else {strcpy(pdata->interface,"null");fclose(fd);break;}
    }
}
//======================================================================
char * chekfaceold ( void)
{
    checkface ();
    char *tab3,*intface,*ifaceend,*intface2;
    tab3 = readfunc(gtk_entry_get_text (GTK_ENTRY (pdata->entry_set_iwconfig)),NULL,NULL,0);
    compresspaces(tab3);
    intface = strstr(tab3,"ESSID");
    intface2 = strstr(tab3,"IEEE");
    if (intface != NULL )
    {
        while (1)
        {
            --intface;
            if (*intface == '\n')break;
        }
        ifaceend = ++intface;
        while (1)
        {
            ++ifaceend;
            if (*ifaceend == ' ')break;
        }
        *ifaceend = '\0';
        strcpy(pdata->interface,intface);
        g_free(tab3);
        return pdata->interface;
    }
    if (intface2 != NULL )
    {
        while (1)
        {
            --intface2;
            if (*intface2 == '\n')break;
        }
        ifaceend = ++intface2;
        while (1)
        {
            ++ifaceend;
            if (*ifaceend == ' ')break;
        }
        *ifaceend = '\0';
        strcpy(pdata->interface,intface2);
        g_free(tab3);
        return pdata->interface;
    }
    g_free(tab3);
    strcpy(pdata->interface,"Not found");
    return pdata->interface;
}
void findfaceset(void)
{
    strcpy(pdata->interface , gtk_entry_get_text (GTK_ENTRY (pdata->entry_set_inter)));
}

int Init_Global_Resource_File(gchar *Resource_File)
{
    FILE *fil=fopen(Resource_File,"r");
    if (!fil){fprintf(stderr,"Loading postfish-gtkrc file found at %s\n",Resource_File);return 0;}
    else {fclose(fil);
        gtk_rc_add_default_file (Resource_File);
        gtk_rc_parse(Resource_File);return 1;
    }
}
void stylcolor(GtkWidget * widget,gchar * path,GtkStateType state)
{
    GdkPixbuf *pixbuf = NULL;
    GdkPixmap *pixmap;
    GtkStyle * style;
    GError    *err1 = NULL ;
    pixbuf = gdk_pixbuf_new_from_file(path,&err1);
    if (pixbuf)
    {
        gdk_pixbuf_render_pixmap_and_mask
        (pixbuf,
         &pixmap,
         NULL,
         255);
        style =  gtk_style_new ();
        style->bg_pixmap[state] = pixmap ;
        gtk_widget_set_style(widget,style);
        gdk_pixbuf_unref(pixbuf);

    }
    else {     printf("%s create failed: %s!!\n",path, err1->message );
        g_error_free ( err1 ) ;
    }
}

void newstyle(GtkWidget *widget)
{
    GtkStyle * style;
    style =  gtk_style_new ();
    gtk_widget_set_style(widget,style);
}
void resetstyle(GtkWidget * widget)
{
    gtk_widget_restore_default_style (widget);
}
void toggled1 ( void )
{
    if (gtk_toggle_button_get_active (GTK_TOGGLE_BUTTON (pdata->checkbutton1)))
    {
        create_docklet();

    } else {
        gtk_toggle_button_set_active (GTK_TOGGLE_BUTTON (pdata->checkbutton3),FALSE);
        destroy_docklet();
    }
}

void toggled3 ( void )
{
    if (gtk_toggle_button_get_active (GTK_TOGGLE_BUTTON (pdata->checkbutton3)))
    {
        gtk_toggle_button_set_active (GTK_TOGGLE_BUTTON (pdata->checkbutton1),TRUE);
    } else {

    }
}

void toggled11 ( void )
{
    if (gtk_toggle_button_get_active (GTK_TOGGLE_BUTTON (pdata->checkbutton11)))
    {
        gtk_toggle_button_set_active (GTK_TOGGLE_BUTTON (pdata->checkbutton4),FALSE);
    } else {

    }
}
void toggled4 ( void )
{
    if (gtk_toggle_button_get_active (GTK_TOGGLE_BUTTON (pdata->checkbutton4)))
    {
        gtk_toggle_button_set_active (GTK_TOGGLE_BUTTON (pdata->checkbutton11),FALSE);
    } else {

    }
}
void togglednetkey (GtkToggleButton *togglebutton,GtkWidget *entry)
{
    if (gtk_toggle_button_get_active (togglebutton))
    {
    gtk_entry_set_visibility (GTK_ENTRY (entry), TRUE);
    } else {
    gtk_entry_set_visibility (GTK_ENTRY (entry), FALSE);
    }
}

void on_spinbutton1_value_changed(void)
{
    if (gtk_spin_button_get_value(GTK_SPIN_BUTTON( pdata->spinbutton1))>=gtk_spin_button_get_value(GTK_SPIN_BUTTON( pdata->spinbutton5)))
        gtk_spin_button_set_value (GTK_SPIN_BUTTON( pdata->spinbutton5),gtk_spin_button_get_value(GTK_SPIN_BUTTON( pdata->spinbutton1))+1);
}
void on_spinbutton5_value_changed(void)
{
    if (gtk_spin_button_get_value(GTK_SPIN_BUTTON( pdata->spinbutton5))<=gtk_spin_button_get_value(GTK_SPIN_BUTTON( pdata->spinbutton1)))
        gtk_spin_button_set_value (GTK_SPIN_BUTTON( pdata->spinbutton1),gtk_spin_button_get_value(GTK_SPIN_BUTTON( pdata->spinbutton5))-1);
    if (gtk_spin_button_get_value(GTK_SPIN_BUTTON( pdata->spinbutton5))>=gtk_spin_button_get_value(GTK_SPIN_BUTTON( pdata->spinbutton2)))
        gtk_spin_button_set_value (GTK_SPIN_BUTTON( pdata->spinbutton2),gtk_spin_button_get_value(GTK_SPIN_BUTTON( pdata->spinbutton5))+1);
}
void on_spinbutton2_value_changed(void)
{
    if (gtk_spin_button_get_value(GTK_SPIN_BUTTON( pdata->spinbutton2))<=gtk_spin_button_get_value(GTK_SPIN_BUTTON( pdata->spinbutton5)))
        gtk_spin_button_set_value (GTK_SPIN_BUTTON( pdata->spinbutton5),gtk_spin_button_get_value(GTK_SPIN_BUTTON( pdata->spinbutton2))-1);
}
int find(char *filepath,char *def)
{
    struct dirent **namelist;
    int n,s=1;
    n = scandir(filepath, &namelist, 0, alphasort);
    if (n > 2)
    {
        while (2<n--) {
            free(namelist[n]);
            if (strstr(def,namelist[n]->d_name)!=0){free(namelist);return 1;}
            ++s;
        }
        free(namelist);
        return -1;
    }
    else {
        return -1;
    }
}

int findfile(const char *filepath)
{
    int a = strlen(filepath);
    char * filetemp = (char *) g_malloc(a+1);
    char * filetemp2;
    strcpy(filetemp,filepath);
    while (1)
    {
        if (*(filetemp + a)=='/')
        {
            *(filetemp + a)='\0';
            filetemp2 = filetemp + a + 1;
            break;
        }
        if (a==0){
            g_free(filetemp);
            return -1;
        }
        --a;
    }
    struct dirent **namelist;
    int n;
    n = scandir(filetemp, &namelist, 0, alphasort);
    if (n > 2)
    {
        while (2<n--) {
            free(namelist[n]);
            if (strstr(filetemp2,namelist[n]->d_name)!=0&&strlen(filetemp2) == strlen(namelist[n]->d_name))
            {
                free(namelist);
                g_free(filetemp);
                return 1;
            }
        }
        free(namelist);
        g_free(filetemp);
        return -1;
    }
    else {
        g_free(filetemp);
        return -1;
    }
}
