#include <config.h>
#include <glib/gi18n.h>
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <gtk/gtk.h>
#include <gdk/gdkx.h>
#include <X11/Xatom.h>
#include <libnotify/notify.h>
#include "callback.h"
#include "docklet.h"
#include "eggtrayicon.h"
#include "gwifimeter.h"
#include "profil.h"

#define ICONS_DIR PACKAGE_DATA_DIR G_DIR_SEPARATOR_S "themes/icons/"

struct scan **scanstruct;
//==========================================================================
void winshow( void )
{
    gtk_notebook_set_current_page(GTK_NOTEBOOK(pdata->notebook1),0);
    gtk_widget_show (pdata->window);
}
void showsetting( void )
{
    gtk_notebook_set_current_page(GTK_NOTEBOOK(pdata->notebook1),3);
    gtk_widget_show (pdata->window);
}
void shownetsetting( void )
{
    gtk_notebook_set_current_page(GTK_NOTEBOOK(pdata->notebook1),1);
    gtk_widget_show (pdata->window);
}
void winhide( void )
{
    gtk_widget_hide (pdata->window);
}
void quit( void )
{
    gtk_main_quit ();
}
//==========================================================================
void autoconnect(void)
{
int len=pdata->tab_profil[0]->len;
int lenscan=scanstruct[0]->len;
if(len>0)
         {
         while(len--)
              {
              lenscan=scanstruct[0]->len;
              while(lenscan--)
                              {
                              if(strstr(pdata->tab_profil[len]->essid,scanstruct[lenscan]->essid)!=NULL&&pdata->tab_profil[len]->available == 1)
                                        {
                                        gtk_combo_box_set_active (GTK_COMBO_BOX (pdata->comboboxentry1),len);
                                        gtk_button_clicked (GTK_BUTTON(pdata->button_connect));
                                        return;
                                        }
                              }
              }
         }
}
void scan_struct(void)
{
    gchar * scanbuf = readfunc(gtk_entry_get_text (GTK_ENTRY (pdata->entry_set_iwlist)),pdata->interface,"scan",2);
    char *target1,*target,*cell1,*cell2;
    int len=0;
    scanstruct = (struct scan **)g_malloc(sizeof(struct scan *));
    cell1 = strstr(scanbuf,"Cell");
    if(cell1!=NULL)
    {
    while(1)
    {
    scanstruct = (struct scan **)g_realloc(scanstruct,(len+1) * sizeof(struct scan *));
    scanstruct[len] = (struct scan *)malloc(sizeof(struct scan));
    cell2 = strstr(cell1+1,"Cell");
    target=search("ESSID",cell1,cell2);
    if(target!=NULL){
                    target1=search("\"",target+7,cell2);
                    if(target1!=NULL
					   &&target+8<target1
					   )
                                {
							    //printf("target+7 - %s\n",target+7);
                                strncpy(scanstruct[len]->essid = (gchar *)g_malloc(target1-target-7+2),target+7,target1-target-7);
                                scanstruct[len]->essid[target1-target-7] = '\0';
                                if(cell2!=NULL)strncpy(scanstruct[len]->cell = (gchar *)g_malloc(cell2-cell1+1),cell1,cell2-cell1);
                                else strncpy(scanstruct[len]->cell = (gchar *)g_malloc(strlen(cell1)+1),cell1,strlen(cell1));
                                ++len;
                                scanstruct[0]->len=len;
                                }else {
									  strcpy(scanstruct[len]->essid = (gchar *)g_malloc(4),"");
									if(cell2!=NULL)strncpy(scanstruct[len]->cell = (gchar *)g_malloc(cell2-cell1+1),cell1,cell2-cell1);
                                else strncpy(scanstruct[len]->cell = (gchar *)g_malloc(strlen(cell1)+1),cell1,strlen(cell1));
                                ++len;
                                scanstruct[0]->len=len;
                                      //printf("target-%s\n",scanstruct[len]->essid);
									break;
                                      }
                    }else {
                          break;
                          }
    if(cell2!=NULL)cell1=cell2;
    else break;
    }
    }else {
           scanstruct[0] = (struct scan *)malloc(sizeof(struct scan));
           scanstruct[0]->len=0;
          }
    g_free(scanbuf);
    return ;
}

void free_scan_struct(void)
{
int len=scanstruct[0]->len;
//printf("free len - %d\n",len);
if(len==0){
           g_free(scanstruct[0]);
           //printf("free struct scan *\n");
           g_free(scanstruct);
           //printf("free struct scan **\n");
           }
else while(len)
        {
        --len;
        free(scanstruct[len]->essid);
        //printf("free essid\n");
        free(scanstruct[len]->cell);
        //printf("free cell\n");
        if(len==0){
                        g_free(scanstruct[0]); 
                        //printf("free struct scan *\n"); 
                        g_free(scanstruct);
                        //printf("free struct scan **\n");
                        }
        }
        //printf("free end\n");
}

void show_notifi ( gchar * summary,gchar * mesage,gint timeout )
{
    NotifyNotification *n;  

    notify_init("Basics");
    if (pdata->tray_icon)n = notify_notification_new (summary,mesage,NULL, pdata->tray_icon);
    else n = notify_notification_new (summary,mesage,NULL, NULL);
    notify_notification_set_timeout (n, timeout);
    if (!notify_notification_show (n, NULL)) 
    {
	fprintf(stderr, "failed to send notification\n");
	return ;
    }
    g_object_unref(G_OBJECT(n));
}

void stantray(gdouble new_val)
{
    if (pdata->tray_icon){
        gdouble low = (gtk_spin_button_get_value(GTK_SPIN_BUTTON( pdata->spinbutton1))/100);
        gdouble midle = (gtk_spin_button_get_value(GTK_SPIN_BUTTON( pdata->spinbutton5))/100);
        gdouble high = (gtk_spin_button_get_value(GTK_SPIN_BUTTON( pdata->spinbutton2))/100);
        gdk_threads_enter();
        if(pdata->acces==0)new_val=0;
        if (new_val>=high) {verygood();}
        if (new_val>=midle && new_val<high) {good();}
        if (new_val>=low && new_val<midle) {medium();}
        if (new_val<low&&new_val>0) {bad();}
        if (new_val==0) {
                         nosignal();
                         scan_struct();
                         //gchar * redbuf = readfunc(gtk_entry_get_text (GTK_ENTRY (pdata->entry_set_iwlist)),pdata->interface,"scan",2);
                         if(scanstruct[0]->len>0)
                                                        {
                                                        if(pdata->winet<=0)
                                                                        {
                                                                        show_notifi ( "GwifiMeter","Found new wifi network",5000 );
                                                                        pdata->winet=2;
                                                         if (
															 //gtk_toggle_button_get_active (GTK_TOGGLE_BUTTON (pdata->checkbutton8))&&
                                                         (GTK_WIDGET_FLAGS (pdata->window) & GTK_VISIBLE) == 0)
                                                                        autoconnect();
                                                                        }else pdata->winet-=1;
                                                        }
                                                        else 
                                                            {
                                                      if(pdata->winet!=0)
                                                                        {
                                                                        show_notifi ( "GwifiMeter","No wifi network",5000 );
                                                                        pdata->winet=0;
                                                                        }
                                                            }
                         //g_free(redbuf);
                         free_scan_struct();
                         }
                         else pdata->winet=0;
        
        gdk_flush ();
        gdk_threads_leave();
    }
}

void bad( void )
{
    if (pdata->tray_icon)
        gtk_image_set_from_pixbuf (GTK_IMAGE (pdata->icon), pdata->pixbuf3);

    if (pdata->tooltips)
    {
        gtk_tooltips_set_tip(pdata->tooltips, pdata->tray_icon, _("GwifiMeter - Low signal level."), NULL);
        gtk_widget_show(pdata->icon);
        
    }
}
void good( void )
{
    if (pdata->tray_icon)
        gtk_image_set_from_pixbuf (GTK_IMAGE (pdata->icon), pdata->pixbuf1);

    if (pdata->tooltips)
    {
        gtk_tooltips_set_tip(pdata->tooltips, pdata->tray_icon, _("GwifiMeter - Good signal level."), NULL);
        gtk_widget_show(pdata->icon);
    }
}
void medium( void )
{
    if (pdata->tray_icon)
        gtk_image_set_from_pixbuf (GTK_IMAGE (pdata->icon), pdata->pixbuf2);

    if (pdata->tooltips)
    {
        gtk_tooltips_set_tip(pdata->tooltips, pdata->tray_icon, _("GwifiMeter - Medium signal level."), NULL);
        gtk_widget_show(pdata->icon);
    }
}
void verygood( void )
{
    if (pdata->tray_icon)
        gtk_image_set_from_pixbuf (GTK_IMAGE (pdata->icon), pdata->pixbuf5);
    if (pdata->tooltips)
    {
        gtk_tooltips_set_tip(pdata->tooltips, pdata->tray_icon, _("GwifiMeter - Very good signal level."), NULL);
        gtk_widget_show(pdata->icon);	
    }
}
void nosignal( void )
{
    if (pdata->tray_icon)
        gtk_image_set_from_pixbuf (GTK_IMAGE (pdata->icon), pdata->pixbuf4);

    if (pdata->tooltips)
    {
        gtk_tooltips_set_tip(pdata->tooltips, pdata->tray_icon, _("GwifiMeter - No signal."), NULL);
        gtk_widget_show(pdata->icon);
    }
}
void on_systray_click1(GtkWidget * widget, GdkEventButton * event, gpointer data)
{
    switch (event->button)
    {
    case 1:
        if (GTK_WIDGET_VISIBLE (pdata->window))
        {
            gtk_widget_hide (pdata->window);
			if (pdata->window_con)gtk_widget_hide (pdata->window_con);
            if (pdata->scann)
			{
				gtk_widget_destroy (pdata->scann);
				pdata->scann=NULL;
			}
            return;
        }
        if (!GTK_WIDGET_VISIBLE (pdata->window))
        {
            gtk_widget_show (pdata->window);
			if (pdata->window_con)gtk_widget_show (pdata->window_con);
            if(pdata->winet>0&&gtk_toggle_button_get_active (GTK_TOGGLE_BUTTON (pdata->checkbutton8)))gtk_button_clicked (GTK_BUTTON(pdata->button_scan));
            return;
        }
        break;
    case 2:
//                printf("wykryto klikniecie 2 klawisz\n");
        break;
    case 3:
//                printf("wykryto klikniecie 3 klawisz\n");

        if (pdata->menu)gtk_menu_popup(GTK_MENU(pdata->menu), NULL, NULL, NULL, NULL,event->button, event->time);
        break;
    }
}
void destroy_docklet(void)
{
    gdk_pixbuf_unref(pdata->pixbuf1);
    gdk_pixbuf_unref(pdata->pixbuf2);
    gdk_pixbuf_unref(pdata->pixbuf3);
    gdk_pixbuf_unref(pdata->pixbuf4);
    gdk_pixbuf_unref(pdata->pixbuf5);
    gdk_pixbuf_unref(pdata->pixcon1);
    gdk_pixbuf_unref(pdata->pixcon2);
    gdk_pixbuf_unref(pdata->pixcon3);
    gdk_pixbuf_unref(pdata->pixcon4);
    gdk_pixbuf_unref(pdata->pixcon5);
    gtk_widget_destroy (GTK_WIDGET (pdata->icon));
    gtk_widget_destroy (GTK_WIDGET (pdata->box));
    gtk_widget_destroy (GTK_WIDGET (pdata->tray_icon));

    pdata->pixbuf1 = NULL;
    pdata->pixbuf2 = NULL;
    pdata->pixbuf3 = NULL;
    pdata->pixbuf4 = NULL;
    pdata->pixbuf5 = NULL;
    pdata->pixcon1 = NULL;
    pdata->pixcon2 = NULL;
    pdata->pixcon3 = NULL;
    pdata->pixcon4 = NULL;
    pdata->pixcon5 = NULL;
    pdata->tray_icon = NULL;
}
void create_docklet(void)
{
    //GtkWidget *icon;
    //GtkWidget *box;
    //GdkPixbuf *pixbuf1;
    //GdkPixbuf *pixbuf2;
    //GdkPixbuf *pixbuf3;
    //GdkPixbuf *pixbuf4;
    //GdkPixbuf *pixbuf5;
    //GtkWidget *tray_icon;
    gchar *buf = (char*)g_malloc(100);
    GError    *err1 = NULL ;
    pdata->tray_icon = GTK_WIDGET (egg_tray_icon_new("Gwifimeter"));
    if (!pdata->tray_icon)
    {
        printf(_("Unable to create system-tray docklet"));
        return;
    }
    gtk_widget_realize(GTK_WIDGET(pdata->tray_icon));

    pdata->icon = gtk_image_new ();
    pdata->box = gtk_event_box_new ();
    gtk_container_add (GTK_CONTAINER (pdata->box), pdata->icon);
    gtk_container_add (GTK_CONTAINER (pdata->tray_icon), pdata->box);
    gtk_widget_show_all (GTK_WIDGET (pdata->tray_icon));

    g_signal_connect (G_OBJECT(pdata->tray_icon), "button-press-event", G_CALLBACK(on_systray_click1), pdata->icon);

    strcpy(buf,ICONS_DIR);
    strcat(buf,pdata->diricon);
    strcat(buf,"/good.png");

    pdata->pixbuf1 = gdk_pixbuf_new_from_file (buf, &err1);
    if (!pdata->pixbuf1)
    {
        printf("Icon create failed: %s!!\n", err1->message );
        err1 = NULL;

        strcpy(buf,"../themes/icons/");
        strcat(buf,pdata->diricon);
        strcat(buf,"/good.png");

        pdata->pixbuf1 = gdk_pixbuf_new_from_file (buf, &err1);
        if (!pdata->pixbuf1)
        {
            printf("Icon create failed: %s!!\n", err1->message);
            err1 = NULL ;

            gtk_toggle_button_set_active (GTK_TOGGLE_BUTTON (pdata->checkbutton1),FALSE);
            return;
        }
    }

    strcpy(buf,ICONS_DIR);
    strcat(buf,pdata->diricon);
    strcat(buf,"/medium.png");

    pdata->pixbuf2 = gdk_pixbuf_new_from_file (buf, &err1);
    if (!pdata->pixbuf2)
    {
        printf("Icon create failed: %s!!\n", err1->message );
        err1 = NULL ;

        strcpy(buf,"../themes/icons/");
        strcat(buf,pdata->diricon);
        strcat(buf,"/medium.png");

        pdata->pixbuf2 = gdk_pixbuf_new_from_file (buf, &err1);
        if (!pdata->pixbuf2)
        {
            printf("Icon create failed: %s!!\n", err1->message);
            err1 = NULL ;
            gtk_toggle_button_set_active (GTK_TOGGLE_BUTTON (pdata->checkbutton1),FALSE);
            return;
        }
    }

    strcpy(buf,ICONS_DIR);
    strcat(buf,pdata->diricon);
    strcat(buf,"/bad.png");

    pdata->pixbuf3 = gdk_pixbuf_new_from_file (buf, &err1);
    if (!pdata->pixbuf3)
    {
        printf("Icon create failed: %s!!\n", err1->message );
        err1 = NULL ;

        strcpy(buf,"../themes/icons/");
        strcat(buf,pdata->diricon);
        strcat(buf,"/bad.png");

        pdata->pixbuf3 = gdk_pixbuf_new_from_file (buf, &err1);
        if (!pdata->pixbuf3)
        {
            printf("Icon create failed: %s!!\n", err1->message );
            err1 = NULL;
            gtk_toggle_button_set_active (GTK_TOGGLE_BUTTON (pdata->checkbutton1),FALSE);
            return;
        }
    }

    strcpy(buf,ICONS_DIR);
    strcat(buf,pdata->diricon);
    strcat(buf,"/nosignal.png");

    pdata->pixbuf4 = gdk_pixbuf_new_from_file (buf, &err1);
    if (!pdata->pixbuf4)
    {
        printf("Icon create failed: %s!!\n", err1->message );
        err1 = NULL;

        strcpy(buf,"../themes/icons/");
        strcat(buf,pdata->diricon);
        strcat(buf,"/nosignal.png");

        pdata->pixbuf4 = gdk_pixbuf_new_from_file (buf, &err1);
        if (!pdata->pixbuf4)
        {
            printf("Icon create failed: %s!!\n", err1->message );
            err1 = NULL;
            gtk_toggle_button_set_active (GTK_TOGGLE_BUTTON (pdata->checkbutton1),FALSE);
            return;
        }
    }

    strcpy(buf,ICONS_DIR);
    strcat(buf,pdata->diricon);
    strcat(buf,"/verygood.png");

    pdata->pixbuf5 = gdk_pixbuf_new_from_file (buf, &err1);
    if (!pdata->pixbuf5)
    {
        printf("Icon create failed: %s!!\n", err1->message);
        err1 = NULL;

        strcpy(buf,"../themes/icons/");
        strcat(buf,pdata->diricon);
        strcat(buf,"/verygood.png");

        pdata->pixbuf5 = gdk_pixbuf_new_from_file (buf, &err1);
        if (!pdata->pixbuf5)
        {
            printf("Icon create failed: %s!!\n", err1->message );
            err1 = NULL ;
            gtk_toggle_button_set_active (GTK_TOGGLE_BUTTON (pdata->checkbutton1),FALSE);
            return;
        }
    }
    strcpy(buf,ICONS_DIR);
    strcat(buf,pdata->diricon);
    strcat(buf,"/con1.png");

    pdata->pixcon1 = gdk_pixbuf_new_from_file (buf, &err1);
    if (!pdata->pixcon1)
    {
        printf("Icon create failed: %s!!\n", err1->message);
        err1 = NULL;

        strcpy(buf,"../themes/icons/");
        strcat(buf,pdata->diricon);
        strcat(buf,"/con1.png");

        pdata->pixcon1 = gdk_pixbuf_new_from_file (buf, &err1);
        if (!pdata->pixcon1)
        {
            printf("Icon create failed: %s!!\n", err1->message );
            err1 = NULL ;
            gtk_toggle_button_set_active (GTK_TOGGLE_BUTTON (pdata->checkbutton1),FALSE);
            return;
        }
    }
    strcpy(buf,ICONS_DIR);
    strcat(buf,pdata->diricon);
    strcat(buf,"/con2.png");

    pdata->pixcon2 = gdk_pixbuf_new_from_file (buf, &err1);
    if (!pdata->pixcon2)
    {
        printf("Icon create failed: %s!!\n", err1->message);
        err1 = NULL;

        strcpy(buf,"../themes/icons/");
        strcat(buf,pdata->diricon);
        strcat(buf,"/con2.png");

        pdata->pixcon2 = gdk_pixbuf_new_from_file (buf, &err1);
        if (!pdata->pixcon2)
        {
            printf("Icon create failed: %s!!\n", err1->message );
            err1 = NULL ;
            gtk_toggle_button_set_active (GTK_TOGGLE_BUTTON (pdata->checkbutton1),FALSE);
            return;
        }
    }
    strcpy(buf,ICONS_DIR);
    strcat(buf,pdata->diricon);
    strcat(buf,"/con3.png");

    pdata->pixcon3 = gdk_pixbuf_new_from_file (buf, &err1);
    if (!pdata->pixcon3)
    {
        printf("Icon create failed: %s!!\n", err1->message);
        err1 = NULL;

        strcpy(buf,"../themes/icons/");
        strcat(buf,pdata->diricon);
        strcat(buf,"/con3.png");

        pdata->pixcon3 = gdk_pixbuf_new_from_file (buf, &err1);
        if (!pdata->pixcon3)
        {
            printf("Icon create failed: %s!!\n", err1->message );
            err1 = NULL ;
            gtk_toggle_button_set_active (GTK_TOGGLE_BUTTON (pdata->checkbutton1),FALSE);
            return;
        }
    }
    strcpy(buf,ICONS_DIR);
    strcat(buf,pdata->diricon);
    strcat(buf,"/con4.png");

    pdata->pixcon4 = gdk_pixbuf_new_from_file (buf, &err1);
    if (!pdata->pixcon4)
    {
        printf("Icon create failed: %s!!\n", err1->message);
        err1 = NULL;

        strcpy(buf,"../themes/icons/");
        strcat(buf,pdata->diricon);
        strcat(buf,"/con4.png");

        pdata->pixcon4 = gdk_pixbuf_new_from_file (buf, &err1);
        if (!pdata->pixcon4)
        {
            printf("Icon create failed: %s!!\n", err1->message );
            err1 = NULL ;
            gtk_toggle_button_set_active (GTK_TOGGLE_BUTTON (pdata->checkbutton1),FALSE);
            return;
        }
    }
    strcpy(buf,ICONS_DIR);
    strcat(buf,pdata->diricon);
    strcat(buf,"/con5.png");

    pdata->pixcon5 = gdk_pixbuf_new_from_file (buf, &err1);
    if (!pdata->pixcon5)
    {
        printf("Icon create failed: %s!!\n", err1->message);
        err1 = NULL;

        strcpy(buf,"../themes/icons/");
        strcat(buf,pdata->diricon);
        strcat(buf,"/con5.png");

        pdata->pixcon5 = gdk_pixbuf_new_from_file (buf, &err1);
        if (!pdata->pixcon5)
        {
            printf("Icon create failed: %s!!\n", err1->message );
            err1 = NULL ;
            gtk_toggle_button_set_active (GTK_TOGGLE_BUTTON (pdata->checkbutton1),FALSE);
            return;
        }
    }
    gtk_image_set_from_pixbuf (GTK_IMAGE (pdata->icon), pdata->pixbuf4);
    g_free(buf);
    //pdata->icon = icon;
    //pdata->tray_icon = tray_icon;
    //pdata->box =  box;
    //pdata->pixbuf1 = pixbuf1;
    //pdata->pixbuf2 = pixbuf2;
    //pdata->pixbuf3 = pixbuf3;
    //pdata->pixbuf4 = pixbuf4;
    //pdata->pixbuf5 = pixbuf5;
    menutray(pdata->tray_icon);
}
void menutray(GtkWidget *tray_icon)
{
    //GtkWidget *menu;
    //GtkWidget *menuitem;
    //GtkWidget *image;

    pdata->menu = gtk_menu_new();

    pdata->menuitem = gtk_menu_item_new_with_mnemonic(_("Show"));
    gtk_menu_shell_append(GTK_MENU_SHELL(pdata->menu), pdata->menuitem);
    g_signal_connect(GTK_OBJECT(pdata->menuitem), "activate", G_CALLBACK(winshow), NULL);
    pdata->menuitem = gtk_menu_item_new_with_mnemonic(_("Show net setting"));
    gtk_menu_shell_append(GTK_MENU_SHELL(pdata->menu), pdata->menuitem);
    g_signal_connect(GTK_OBJECT(pdata->menuitem), "activate", G_CALLBACK(shownetsetting), NULL);
    pdata->menuitem = gtk_menu_item_new_with_mnemonic(_("Show setting"));
    gtk_menu_shell_append(GTK_MENU_SHELL(pdata->menu), pdata->menuitem);
    g_signal_connect(GTK_OBJECT(pdata->menuitem), "activate", G_CALLBACK(showsetting), NULL);
    pdata->menuitem = gtk_menu_item_new_with_mnemonic(_("Hide"));
    gtk_menu_shell_append(GTK_MENU_SHELL(pdata->menu), pdata->menuitem);
    g_signal_connect(GTK_OBJECT(pdata->menuitem), "activate", G_CALLBACK(winhide), NULL);
    pdata->menuitem = gtk_image_menu_item_new_with_mnemonic(_("Exit"));
    gtk_menu_shell_append(GTK_MENU_SHELL(pdata->menu), pdata->menuitem);
    g_signal_connect(GTK_OBJECT(pdata->menuitem), "activate", G_CALLBACK(quit), NULL);

    gchar *buf = (char*)g_malloc(100);
    strcpy(buf,ICONS_DIR);
	strcat(buf,pdata->diricon);
    if ( find(buf,"exit.png")<0)
    {
        printf("Icon create failed!! %s\n",buf);
        strcpy(buf,"../themes/icons/");
        strcat(buf,pdata->diricon);

        if ( find(buf,"exit.png")<0)
        {
            printf("Icon create failed!! %s\n",buf);
        }
        else
        {
            strcat(buf,"/exit.png");
            pdata->image = gtk_image_new_from_file(buf);
            gtk_image_menu_item_set_image(GTK_IMAGE_MENU_ITEM(pdata->menuitem), pdata->image);
        }
    }
    else {
        strcat(buf,"/exit.png");
        pdata->image = gtk_image_new_from_file(buf);
        gtk_image_menu_item_set_image(GTK_IMAGE_MENU_ITEM(pdata->menuitem), pdata->image);
    }


    gtk_widget_show_all(pdata->menu);
    g_free(buf);
    //pdata->menu = menu;
    //pdata->menuitem = menuitem;
    //pdata->image = image;
    gtk_tooltips_set_tip(pdata->tooltips, pdata->tray_icon, "GwifiMeter", NULL);
}

