#include <config.h>
#include <signal.h>
#include <gtk/gtk.h>
#include <gdk/gdk.h>
#include <stdio.h>
#include <string.h>
#include "gwifimeter.h"
#include "callback.h"
#include "textview1.h"
#include "scan.h"
#include "but_connect.h"
#include "profil.h"
#include "docklet.h"
#include "interface.h"
//#include <glib/gi18n.h>
#include <locale.h>

#define ICONS_DIR PACKAGE_DATA_DIR G_DIR_SEPARATOR_S "themes/rc/"

#ifdef ENABLE_NLS
#  include <libintl.h>
#  undef _
#  define _(String) dgettext (PACKAGE, String)
#  ifdef gettext_noop
#    define N_(String) gettext_noop (String)
#  else
#    define N_(String) (String)
#  endif
#else
#  define textdomain(String) (String)
#  define gettext(String) (String)
#  define dgettext(Domain,Message) (Message)
#  define dcgettext(Domain,Message,Type) (Message)
#  define bindtextdomain(Domain,Directory) (Domain)
#  define _(String) (String)
#  define N_(String) (String)
#endif

int
main (int argc, char *argv[])
{
  GError *err1 = NULL;

  if (!g_thread_supported ())
    {
      g_thread_init (NULL);
      gdk_threads_init ();
    }
  else
    {
      printf ("g_thread NOT supported\n");
      return 0;
    }
  pdata = g_malloc (sizeof (textset));
//    i18n_init ();
#ifdef ENABLE_NLS
  bindtextdomain (GETTEXT_PACKAGE, PACKAGE_LOCALE_DIR);
  bind_textdomain_codeset (GETTEXT_PACKAGE, "UTF-8");
  textdomain (GETTEXT_PACKAGE);
#endif
  chekuser ();
  prefileread ();
  if (strlen (pdata->themes) > 0 && strstr ("system", pdata->themes) == NULL)
    {
      char *buf = (char *) g_malloc (100);
      strcpy (buf, ICONS_DIR);
      strcat (buf, pdata->themes);
      strcat (buf, "/gtkrc");

      if (0 == Init_Global_Resource_File (buf))
	{
	  strcpy (buf, "../themes/rc/");
	  strcat (buf, pdata->themes);
	  strcat (buf, "/gtkrc");
	  Init_Global_Resource_File (buf);
	}
      g_free (buf);
    }
  gtk_init (&argc, &argv);
  interface ();
  appendprofil ();
  fileread ();


  pdata->stan = 0;
  textset textarg;
  textarg.window = pdata->window;
  textarg.textview1 = pdata->textview1;
  textarg.progresbar0 = pdata->progresbar0;
  textarg.progresbar1 = pdata->progresbar1;
  textarg.progresbar2 = pdata->progresbar2;
  textarg.entry_set_inter = pdata->entry_set_inter;
  textarg.icon = pdata->icon;
  textarg.entry_set_iwconfig = pdata->entry_set_iwconfig;
  textarg.entry_set_timescan = pdata->entry_set_timescan;
  textarg.entry_set_wlasny = pdata->entry_set_wlasny;
  textarg.checkbutton4 = pdata->checkbutton4;
  if ((g_thread_create
       ((GThreadFunc) textview1_function, &textarg, TRUE, &err1)) == NULL)
    {
      printf ("Thread create failed: %s!!\n", err1->message);
      g_error_free (err1);
    }
  if ((con_but =
       g_thread_pool_new ((GFunc) conterm, &textarg, 1, FALSE,
			  &err1)) == NULL)
    {
      printf ("Thread create failed: %s!!\n", err1->message);
      g_error_free (err1);
    }
  if ((scanning =
       g_thread_pool_new ((GFunc) scancon, &textarg, 1, FALSE,
			  &err1)) == NULL)
    {
      printf ("Thread create failed: %s!!\n", err1->message);
      g_error_free (err1);
    }
  signal (SIGCHLD, sigchld_handler);
  gdk_threads_enter ();
  gtk_main ();
  gdk_threads_leave ();
  g_free (pdata);

  return 0;
}
