#include <config.h>
#include <glib/gi18n.h>
#include <signal.h>
#include <gtk/gtk.h>
#include <stdio.h>
#include <string.h>
#include <stdlib.h>
#include <sys/types.h>
#include <sys/stat.h>
#include <unistd.h>
#include <gdk/gdkkeysyms.h>
#include "gwifimeter.h"
#include "interface.h"
#include "callback.h"
#include "scan.h"
#include "but_connect.h"
#include "profil.h"

#define ICONS_DIR PACKAGE_DATA_DIR G_DIR_SEPARATOR_S "themes/icons/"

void
interface (void)
{
  pdata->tooltips = gtk_tooltips_new ();
  gtk_tooltips_enable (pdata->tooltips);
  window ();
  notebook ();
  zakl_status (0);
  zakl_sieci (1);
  zakl_podg (2);
  zakl_ustawienia (3);
  zakl_o (4);
  gtk_notebook_set_current_page (GTK_NOTEBOOK (pdata->notebook1), 0);
}

void
window (void)
{
  GError *err1 = NULL;
  pdata->window = gtk_window_new (GTK_WINDOW_TOPLEVEL);
  gtk_widget_set_size_request (pdata->window, 500, 340);
  gtk_window_set_title (GTK_WINDOW (pdata->window), _("GwifiMeter"));
  gchar *buf = (char *) g_malloc (100);
  strcpy (buf, ICONS_DIR);
  strcat (buf, pdata->diricon);
  strcat (buf, "/gwifimeter.png");
  pdata->window1_icon_pixbuf = gdk_pixbuf_new_from_file (buf, &err1);
  if (pdata->window1_icon_pixbuf)
    {
      gtk_window_set_icon (GTK_WINDOW (pdata->window),
			   pdata->window1_icon_pixbuf);
      gdk_pixbuf_unref (pdata->window1_icon_pixbuf);
    }
  else
    {
      printf ("Icon create failed: %s!!\n", err1->message);
      err1 = NULL;
      strcpy (buf, "../themes/icons/");
      strcat (buf, pdata->diricon);
      strcat (buf, "/gwifimeter.png");
      pdata->window1_icon_pixbuf = gdk_pixbuf_new_from_file (buf, &err1);

      if (pdata->window1_icon_pixbuf)
	{
	  gtk_window_set_icon (GTK_WINDOW (pdata->window),
			       pdata->window1_icon_pixbuf);
	  gdk_pixbuf_unref (pdata->window1_icon_pixbuf);
	}
      else
	printf ("Icon create failed: %s!!\n", err1->message);
    }
  //g_error_free ( err1 ) ;
  g_free (buf);
  gtk_container_set_border_width (GTK_CONTAINER (pdata->window), 10);
  g_signal_connect (G_OBJECT (pdata->window), "delete_event",
		    G_CALLBACK (windevent), NULL);
  g_signal_connect ((gpointer) pdata->window, "realize",
		    G_CALLBACK (realize_window), NULL);
  gtk_widget_realize (GTK_WIDGET (pdata->window));
}

void
notebook (void)
{
  pdata->notebook1 = gtk_notebook_new ();
  gtk_container_add (GTK_CONTAINER (pdata->window), pdata->notebook1);
  gtk_widget_show (pdata->notebook1);
}

void
zakl_status (int num)
{
//--------------------zakladka status---------------------
  GtkWidget *vbox1 = gtk_vbox_new (FALSE, 2);
  gtk_container_add (GTK_CONTAINER (pdata->notebook1), vbox1);
  gtk_container_set_border_width (GTK_CONTAINER (vbox1), 10);
  gtk_widget_show (vbox1);

  GtkWidget *label1 = gtk_label_new (_("iwconfig output"));
  gtk_box_pack_start (GTK_BOX (vbox1), label1, FALSE, FALSE, 0);
  gtk_widget_show (label1);

  GtkWidget *scrolledwindow1 = gtk_scrolled_window_new (NULL, NULL);
  gtk_box_pack_start (GTK_BOX (vbox1), scrolledwindow1, TRUE, TRUE, 0);
  gtk_scrolled_window_set_policy (GTK_SCROLLED_WINDOW (scrolledwindow1),
				  GTK_POLICY_NEVER, GTK_POLICY_NEVER);
  gtk_widget_show (scrolledwindow1);

  pdata->textview1 = gtk_text_view_new ();
  gtk_text_view_set_editable (GTK_TEXT_VIEW (pdata->textview1), FALSE);
  gtk_text_view_set_cursor_visible (GTK_TEXT_VIEW (pdata->textview1), FALSE);
  gtk_container_add (GTK_CONTAINER (scrolledwindow1), pdata->textview1);
  gtk_widget_show (pdata->textview1);

  pdata->progresbar1 = gtk_progress_bar_new ();
  gtk_progress_bar_set_text (GTK_PROGRESS_BAR (pdata->progresbar1),
			     _("Link quality"));
  gtk_progress_bar_set_bar_style (GTK_PROGRESS_BAR (pdata->progresbar1),
				  GTK_PROGRESS_CONTINUOUS);
  gtk_progress_bar_set_fraction (GTK_PROGRESS_BAR (pdata->progresbar1), 1.0);
  gtk_box_pack_start (GTK_BOX (vbox1), pdata->progresbar1, FALSE, FALSE, 0);
  gtk_widget_show (pdata->progresbar1);

  pdata->progresbar0 = gtk_progress_bar_new ();
  gtk_progress_bar_set_text (GTK_PROGRESS_BAR (pdata->progresbar0),
			     _("Signal level"));
  gtk_progress_bar_set_bar_style (GTK_PROGRESS_BAR (pdata->progresbar0),
				  GTK_PROGRESS_CONTINUOUS);
  gtk_progress_bar_set_fraction (GTK_PROGRESS_BAR (pdata->progresbar0), 1.0);
  gtk_box_pack_start (GTK_BOX (vbox1), pdata->progresbar0, FALSE, FALSE, 0);
  gtk_widget_show (pdata->progresbar0);

  pdata->progresbar2 = gtk_progress_bar_new ();
  gtk_progress_bar_set_text (GTK_PROGRESS_BAR (pdata->progresbar2),
			     _("Noise level"));
  gtk_progress_bar_set_bar_style (GTK_PROGRESS_BAR (pdata->progresbar2),
				  GTK_PROGRESS_CONTINUOUS);
  gtk_progress_bar_set_fraction (GTK_PROGRESS_BAR (pdata->progresbar2), 1.0);
  gtk_box_pack_start (GTK_BOX (vbox1), pdata->progresbar2, FALSE, FALSE, 0);
  gtk_widget_show (pdata->progresbar2);

  GtkWidget *zakl1 = gtk_label_new (_("Status"));
  gtk_notebook_set_tab_label (GTK_NOTEBOOK (pdata->notebook1),
			      gtk_notebook_get_nth_page (GTK_NOTEBOOK
							 (pdata->notebook1),
							 num), zakl1);
  gtk_widget_show (zakl1);

}

//---------------------podglad scanowania------------------------------
void
zakl_podg (int num)
{
  GtkWidget *vbox5 = gtk_vbox_new (FALSE, 0);
  gtk_container_add (GTK_CONTAINER (pdata->notebook1), vbox5);
  gtk_container_set_border_width (GTK_CONTAINER (vbox5), 10);
  gtk_widget_show (vbox5);

  pdata->scrolledwindow2 = gtk_scrolled_window_new (NULL, NULL);
  gtk_box_pack_start (GTK_BOX (vbox5), pdata->scrolledwindow2, TRUE, TRUE, 0);
  gtk_scrolled_window_set_policy (GTK_SCROLLED_WINDOW (pdata->scrolledwindow2), GTK_POLICY_AUTOMATIC, GTK_POLICY_ALWAYS);	//GTK_POLICY_NEVER
  gtk_scrolled_window_set_shadow_type (GTK_SCROLLED_WINDOW
				       (pdata->scrolledwindow2),
				       GTK_SHADOW_IN);
  gtk_widget_show (pdata->scrolledwindow2);

  pdata->textview2 = gtk_text_view_new ();
  gtk_container_add (GTK_CONTAINER (pdata->scrolledwindow2),
		     pdata->textview2);
  gtk_text_view_set_editable (GTK_TEXT_VIEW (pdata->textview2), FALSE);
  gtk_text_view_set_cursor_visible (GTK_TEXT_VIEW (pdata->textview2), FALSE);
  gtk_widget_show (pdata->textview2);
  gtk_text_view_set_wrap_mode (GTK_TEXT_VIEW (pdata->textview2),
			       GTK_WRAP_NONE);

  GtkWidget *seting = gtk_label_new (_("Terminal output"));
  gtk_notebook_set_tab_label (GTK_NOTEBOOK (pdata->notebook1),
			      gtk_notebook_get_nth_page (GTK_NOTEBOOK
							 (pdata->notebook1),
							 num), seting);
  gtk_widget_show (seting);
}

//----------------zakladka sieci---------------------
void
zakl_sieci (int num)
{
  GtkWidget *hboxnet = gtk_hbox_new (FALSE, 0);
  gtk_container_add (GTK_CONTAINER (pdata->notebook1), hboxnet);
  gtk_widget_show (hboxnet);

  GtkWidget *table1 = gtk_table_new (11, 4, TRUE);
  gtk_widget_show (table1);
  gtk_container_add (GTK_CONTAINER (hboxnet), table1);
  gtk_container_set_border_width (GTK_CONTAINER (table1), 5);
  //gtk_table_set_col_spacings(GTK_TABLE(table1),5);
  gtk_widget_show (table1);

  GtkWidget *lab_acces = gtk_label_new (_("Profile"));
  gtk_table_attach (GTK_TABLE (table1), lab_acces, 0, 4, 0, 1,
		    (GtkAttachOptions) (GTK_EXPAND | GTK_FILL),
		    (GtkAttachOptions) (GTK_EXPAND | GTK_FILL), 0, 0);
  gtk_widget_show (lab_acces);

  pdata->comboboxentry1 = gtk_combo_box_entry_new_text ();
  gtk_table_attach (GTK_TABLE (table1), pdata->comboboxentry1, 0, 4, 1, 2,
		    (GtkAttachOptions) (GTK_FILL),
		    (GtkAttachOptions) (GTK_EXPAND | GTK_FILL), 0, 0);
  g_signal_connect ((gpointer) pdata->comboboxentry1, "changed",
		    G_CALLBACK (comboboxentry1_changed), NULL);
  gtk_widget_show (pdata->comboboxentry1);

  pdata->save_profil = gtk_button_new_with_mnemonic (_("Save profile"));
  gtk_table_attach (GTK_TABLE (table1), pdata->save_profil, 0, 2, 2, 3,
		    (GtkAttachOptions) (GTK_FILL),
		    (GtkAttachOptions) (0), 0, 0);
  gtk_widget_show (pdata->save_profil);
  gtk_tooltips_set_tip (pdata->tooltips, pdata->save_profil, _("Save profile"), NULL);
  g_signal_connect (G_OBJECT (pdata->save_profil), "clicked", G_CALLBACK (addprofil),
		    NULL);

  GtkWidget *button_remove =
    gtk_button_new_with_mnemonic (_("Remove profile"));
  gtk_table_attach (GTK_TABLE (table1), button_remove, 2, 4, 2, 3,
		    (GtkAttachOptions) (GTK_FILL), (GtkAttachOptions) (0), 0,
		    0);
  gtk_widget_show (button_remove);
  gtk_tooltips_set_tip (pdata->tooltips, button_remove,
			_("Remove selected profile"), NULL);
  g_signal_connect (G_OBJECT (button_remove), "clicked",
		    G_CALLBACK (delprofil), NULL);

  GtkWidget *lab_mac = gtk_label_new (_("MAC address"));
  gtk_table_attach (GTK_TABLE (table1), lab_mac, 0, 4, 3, 4,
		    (GtkAttachOptions) (GTK_FILL),
		    (GtkAttachOptions) (GTK_EXPAND | GTK_FILL), 0, 0);
  gtk_widget_show (lab_mac);

  pdata->combobox_mac = gtk_combo_box_new_text ();
  gtk_table_attach (GTK_TABLE (table1), pdata->combobox_mac, 0, 1, 4, 5,
		    (GtkAttachOptions) (GTK_FILL),
		    (GtkAttachOptions) (GTK_EXPAND | GTK_FILL), 0, 0);
  gtk_combo_box_append_text (GTK_COMBO_BOX (pdata->combobox_mac), _("None"));
  gtk_combo_box_append_text (GTK_COMBO_BOX (pdata->combobox_mac), _("Set"));
  gtk_combo_box_set_active (GTK_COMBO_BOX (pdata->combobox_mac), 0);
  gtk_widget_show (pdata->combobox_mac);

  pdata->entry_mac = gtk_entry_new ();
  gtk_table_attach (GTK_TABLE (table1), pdata->entry_mac, 1, 4, 4, 5,
		    (GtkAttachOptions) (GTK_EXPAND | GTK_FILL),
		    (GtkAttachOptions) (0), 0, 0);
  gtk_entry_set_max_length (GTK_ENTRY (pdata->entry_mac), 17);
  gtk_widget_show (pdata->entry_mac);

  GtkWidget *lab_ip = gtk_label_new (_("IP address"));
  gtk_table_attach (GTK_TABLE (table1), lab_ip, 0, 4, 5, 6,
		    (GtkAttachOptions) (GTK_FILL),
		    (GtkAttachOptions) (GTK_EXPAND | GTK_FILL), 0, 0);
  gtk_widget_show (lab_ip);

  pdata->combobox_ip = gtk_combo_box_new_text ();
  gtk_table_attach (GTK_TABLE (table1), pdata->combobox_ip, 0, 1, 6, 7,
		    (GtkAttachOptions) (GTK_FILL),
		    (GtkAttachOptions) (GTK_EXPAND | GTK_FILL), 0, 0);
  gtk_combo_box_append_text (GTK_COMBO_BOX (pdata->combobox_ip), (_("None")));
  gtk_combo_box_append_text (GTK_COMBO_BOX (pdata->combobox_ip), (_("Auto")));
  gtk_combo_box_append_text (GTK_COMBO_BOX (pdata->combobox_ip), (_("Stat")));
  gtk_combo_box_set_active (GTK_COMBO_BOX (pdata->combobox_ip), 0);
  gtk_widget_show (pdata->combobox_ip);

  pdata->entry_ip = gtk_entry_new ();
  gtk_table_attach (GTK_TABLE (table1), pdata->entry_ip, 1, 4, 6, 7,
		    (GtkAttachOptions) (GTK_FILL),
		    (GtkAttachOptions) (GTK_EXPAND | GTK_FILL), 0, 0);
  gtk_entry_set_max_length (GTK_ENTRY (pdata->entry_ip), 18);
  gtk_widget_show (pdata->entry_ip);

  GtkWidget *lab_gw = gtk_label_new (_("Gateway IP"));
  gtk_table_attach (GTK_TABLE (table1), lab_gw, 0, 4, 7, 8,
		    (GtkAttachOptions) (GTK_FILL),
		    (GtkAttachOptions) (GTK_EXPAND | GTK_FILL), 0, 0);
  gtk_widget_show (lab_gw);

  pdata->combobox_gw = gtk_combo_box_new_text ();
  gtk_table_attach (GTK_TABLE (table1), pdata->combobox_gw, 0, 1, 8, 9,
		    (GtkAttachOptions) (GTK_FILL),
		    (GtkAttachOptions) (GTK_EXPAND | GTK_FILL), 0, 0);
  gtk_combo_box_append_text (GTK_COMBO_BOX (pdata->combobox_gw), (_("None")));
  gtk_combo_box_append_text (GTK_COMBO_BOX (pdata->combobox_gw), (_("Auto")));
  gtk_combo_box_append_text (GTK_COMBO_BOX (pdata->combobox_gw), (_("Stat")));
  gtk_combo_box_set_active (GTK_COMBO_BOX (pdata->combobox_gw), 0);
  gtk_widget_show (pdata->combobox_gw);

  pdata->entry_gw = gtk_entry_new ();
  gtk_table_attach (GTK_TABLE (table1), pdata->entry_gw, 1, 4, 8, 9,
		    (GtkAttachOptions) (GTK_EXPAND | GTK_FILL),
		    (GtkAttachOptions) (0), 0, 0);
  gtk_entry_set_max_length (GTK_ENTRY (pdata->entry_gw), 15);
  gtk_widget_show (pdata->entry_gw);

  pdata->checkbutton5 =
    gtk_check_button_new_with_mnemonic (_("Activate on startup"));
  gtk_table_attach (GTK_TABLE (table1), pdata->checkbutton5, 0, 4, 9, 10,
		    (GtkAttachOptions) (GTK_FILL), (GtkAttachOptions) (0), 0,
		    0);
  gtk_widget_show (pdata->checkbutton5);
  gtk_tooltips_set_tip (pdata->tooltips, pdata->checkbutton5,
			_("Activate on startup"), NULL);
  pdata->checkbutton7 =
    gtk_check_button_new_with_mnemonic (_("Activate if network available"));
  gtk_table_attach (GTK_TABLE (table1), pdata->checkbutton7, 0, 4, 10, 11,
		    (GtkAttachOptions) (GTK_FILL), (GtkAttachOptions) (0), 0,
		    0);
  gtk_widget_show (pdata->checkbutton7);
  gtk_tooltips_set_tip (pdata->tooltips, pdata->checkbutton7,
			_
			("Activate if network available.You shoulbe suser acces"),
			NULL);
//-------------prawa strona zakladki sieci
  GtkWidget *table2 = gtk_table_new (11, 4, TRUE);
  gtk_widget_show (table2);
  gtk_container_add (GTK_CONTAINER (hboxnet), table2);
  gtk_container_set_border_width (GTK_CONTAINER (table2), 5);
  gtk_table_set_col_spacings (GTK_TABLE (table2), 5);
  gtk_widget_show (table2);

  GtkWidget *lab_nazwa = gtk_label_new (_("Essid"));
  gtk_table_attach (GTK_TABLE (table2), lab_nazwa, 0, 4, 0, 1,
		    (GtkAttachOptions) (GTK_EXPAND | GTK_FILL),
		    (GtkAttachOptions) (GTK_EXPAND | GTK_FILL), 0, 0);
  gtk_widget_show (lab_nazwa);

  pdata->entry_nazwa = gtk_entry_new ();
  gtk_table_attach (GTK_TABLE (table2), pdata->entry_nazwa, 0, 4, 1, 2,
		    (GtkAttachOptions) (GTK_FILL),
		    (GtkAttachOptions) (GTK_EXPAND | GTK_FILL), 0, 0);
  gtk_widget_show (pdata->entry_nazwa);

  pdata->button_connect = gtk_button_new_with_mnemonic (_("Net connect"));
  gtk_table_attach (GTK_TABLE (table2), pdata->button_connect, 0, 2, 2, 3,
		    (GtkAttachOptions) (GTK_FILL),
		    (GtkAttachOptions) (0), 0, 0);
  gtk_tooltips_set_tip (pdata->tooltips, pdata->button_connect,
			_("Net connect"), NULL);
  g_signal_connect (G_OBJECT (pdata->button_connect), "clicked",
		    G_CALLBACK (but_connect), NULL);
  gtk_widget_show (pdata->button_connect);

  pdata->button_scan = gtk_button_new_with_mnemonic (_("Net scan"));	//29
  gtk_table_attach (GTK_TABLE (table2), pdata->button_scan, 2, 4, 2, 3,
		    (GtkAttachOptions) (GTK_FILL),
		    (GtkAttachOptions) (0), 0, 0);
  gtk_tooltips_set_tip (pdata->tooltips, pdata->button_scan, _("Net scan"), NULL);	//30
  g_signal_connect (G_OBJECT (pdata->button_scan), "clicked",
		    G_CALLBACK (scannstart), NULL);
  gtk_widget_show (pdata->button_scan);
  GtkWidget *lab_key = gtk_label_new (_("Key"));
  gtk_table_attach (GTK_TABLE (table2), lab_key, 0, 4, 3, 4,
		    (GtkAttachOptions) (GTK_FILL),
		    (GtkAttachOptions) (GTK_EXPAND | GTK_FILL), 0, 0);
  gtk_widget_show (lab_key);

  pdata->entry_key = gtk_entry_new ();
  gtk_table_attach (GTK_TABLE (table2), pdata->entry_key, 0, 4, 4, 5,
		    (GtkAttachOptions) (GTK_FILL),
		    (GtkAttachOptions) (GTK_EXPAND | GTK_FILL), 0, 0);
  gtk_widget_show (pdata->entry_key);
  gtk_entry_set_max_length (GTK_ENTRY (pdata->entry_key), 64);
  gtk_entry_set_visibility (GTK_ENTRY (pdata->entry_key), FALSE);

  GtkWidget *lab_channel = gtk_label_new (_("Channel"));
  gtk_table_attach (GTK_TABLE (table2), lab_channel, 0, 2, 5, 6,
		    (GtkAttachOptions) (GTK_FILL),
		    (GtkAttachOptions) (GTK_EXPAND | GTK_FILL), 0, 0);
  gtk_widget_show (lab_channel);

  GtkWidget *lab_rate = gtk_label_new (_("Rate"));
  gtk_table_attach (GTK_TABLE (table2), lab_rate, 2, 4, 5, 6,
		    (GtkAttachOptions) (GTK_FILL),
		    (GtkAttachOptions) (GTK_EXPAND | GTK_FILL), 0, 0);
  gtk_widget_show (lab_rate);

  pdata->comboboxentry_channel = gtk_combo_box_new_text ();
  gtk_table_attach (GTK_TABLE (table2), pdata->comboboxentry_channel, 0, 2, 6,
		    7, (GtkAttachOptions) (GTK_FILL),
		    (GtkAttachOptions) (GTK_EXPAND | GTK_FILL), 0, 0);
  gtk_combo_box_append_text (GTK_COMBO_BOX (pdata->comboboxentry_channel),
			     _("Auto"));
  gtk_combo_box_append_text (GTK_COMBO_BOX (pdata->comboboxentry_channel),
			     _("channel 1"));
  gtk_combo_box_append_text (GTK_COMBO_BOX (pdata->comboboxentry_channel),
			     _("channel 2"));
  gtk_combo_box_append_text (GTK_COMBO_BOX (pdata->comboboxentry_channel),
			     _("channel 3"));
  gtk_combo_box_append_text (GTK_COMBO_BOX (pdata->comboboxentry_channel),
			     _("channel 4"));
  gtk_combo_box_append_text (GTK_COMBO_BOX (pdata->comboboxentry_channel),
			     _("channel 5"));
  gtk_combo_box_append_text (GTK_COMBO_BOX (pdata->comboboxentry_channel),
			     _("channel 6"));
  gtk_combo_box_append_text (GTK_COMBO_BOX (pdata->comboboxentry_channel),
			     _("channel 7"));
  gtk_combo_box_append_text (GTK_COMBO_BOX (pdata->comboboxentry_channel),
			     _("channel 8"));
  gtk_combo_box_append_text (GTK_COMBO_BOX (pdata->comboboxentry_channel),
			     _("channel 9"));
  gtk_combo_box_append_text (GTK_COMBO_BOX (pdata->comboboxentry_channel),
			     _("channel 10"));
  gtk_combo_box_append_text (GTK_COMBO_BOX (pdata->comboboxentry_channel),
			     _("channel 11"));
  gtk_combo_box_append_text (GTK_COMBO_BOX (pdata->comboboxentry_channel),
			     _("channel 12"));
  gtk_combo_box_append_text (GTK_COMBO_BOX (pdata->comboboxentry_channel),
			     _("channel 13"));
  gtk_combo_box_append_text (GTK_COMBO_BOX (pdata->comboboxentry_channel),
			     _("channel 14"));
  gtk_combo_box_set_active (GTK_COMBO_BOX (pdata->comboboxentry_channel), 0);
  gtk_widget_show (pdata->comboboxentry_channel);


  pdata->comboboxentry_rate = gtk_combo_box_new_text ();
  gtk_table_attach (GTK_TABLE (table2), pdata->comboboxentry_rate, 2, 4, 6, 7,
		    (GtkAttachOptions) (GTK_FILL),
		    (GtkAttachOptions) (GTK_EXPAND | GTK_FILL), 0, 0);
  gtk_combo_box_append_text (GTK_COMBO_BOX (pdata->comboboxentry_rate),
			     _("Auto"));
  gtk_combo_box_append_text (GTK_COMBO_BOX (pdata->comboboxentry_rate),
			     _("rate 1M"));
  gtk_combo_box_append_text (GTK_COMBO_BOX (pdata->comboboxentry_rate),
			     _("rate 2M"));
  gtk_combo_box_append_text (GTK_COMBO_BOX (pdata->comboboxentry_rate),
			     _("rate 5.5M"));
  gtk_combo_box_append_text (GTK_COMBO_BOX (pdata->comboboxentry_rate),
			     _("rate 9M"));
  gtk_combo_box_append_text (GTK_COMBO_BOX (pdata->comboboxentry_rate),
			     _("rate 11M"));
  gtk_combo_box_append_text (GTK_COMBO_BOX (pdata->comboboxentry_rate),
			     _("rate 18M"));
  gtk_combo_box_append_text (GTK_COMBO_BOX (pdata->comboboxentry_rate),
			     _("rate 24M"));
  gtk_combo_box_append_text (GTK_COMBO_BOX (pdata->comboboxentry_rate),
			     _("rate 36M"));
  gtk_combo_box_append_text (GTK_COMBO_BOX (pdata->comboboxentry_rate),
			     _("rate 54M"));
  gtk_combo_box_set_active (GTK_COMBO_BOX (pdata->comboboxentry_rate), 0);
  gtk_widget_show (pdata->comboboxentry_rate);

  GtkWidget *lab_mode = gtk_label_new (_("Mode"));
  gtk_table_attach (GTK_TABLE (table2), lab_mode, 0, 2, 7, 8,
		    (GtkAttachOptions) (GTK_FILL),
		    (GtkAttachOptions) (GTK_EXPAND | GTK_FILL), 0, 0);
  gtk_widget_show (lab_mode);


  GtkWidget *lab_keymode = gtk_label_new (_("Secure"));
  gtk_table_attach (GTK_TABLE (table2), lab_keymode, 2, 4, 7, 8,
		    (GtkAttachOptions) (GTK_FILL),
		    (GtkAttachOptions) (GTK_EXPAND | GTK_FILL), 0, 0);
  gtk_widget_show (lab_keymode);

  pdata->comboboxentry_mode = gtk_combo_box_new_text ();
  gtk_table_attach (GTK_TABLE (table2), pdata->comboboxentry_mode, 0, 2, 8, 9,
		    (GtkAttachOptions) (GTK_FILL),
		    (GtkAttachOptions) (GTK_EXPAND | GTK_FILL), 0, 0);
  gtk_widget_show (pdata->comboboxentry_mode);
  gtk_combo_box_append_text (GTK_COMBO_BOX (pdata->comboboxentry_mode),
			     _("Managed"));
  gtk_combo_box_append_text (GTK_COMBO_BOX (pdata->comboboxentry_mode),
			     _("Ad-hoc"));
  gtk_combo_box_append_text (GTK_COMBO_BOX (pdata->comboboxentry_mode),
			     _("Master"));
  gtk_combo_box_append_text (GTK_COMBO_BOX (pdata->comboboxentry_mode),
			     _("Monitor"));
  gtk_combo_box_set_active (GTK_COMBO_BOX (pdata->comboboxentry_mode), 0);

  pdata->combobox_keymode = gtk_combo_box_new_text ();
  gtk_table_attach (GTK_TABLE (table2), pdata->combobox_keymode, 2, 4, 8, 9,
		    (GtkAttachOptions) (GTK_FILL),
		    (GtkAttachOptions) (GTK_EXPAND | GTK_FILL), 0, 0);
  gtk_widget_show (pdata->combobox_keymode);
  gtk_combo_box_append_text (GTK_COMBO_BOX (pdata->combobox_keymode),
			     _("Off"));
  gtk_combo_box_append_text (GTK_COMBO_BOX (pdata->combobox_keymode),
			     _("Open"));
  gtk_combo_box_append_text (GTK_COMBO_BOX (pdata->combobox_keymode),
			     _("Restricted"));
  gtk_combo_box_append_text (GTK_COMBO_BOX (pdata->combobox_keymode),
			     ("WPA-PSK/TKIP"));
  gtk_combo_box_append_text (GTK_COMBO_BOX (pdata->combobox_keymode),
			     ("WPA-PSK/AES"));
  gtk_combo_box_set_active (GTK_COMBO_BOX (pdata->combobox_keymode), 0);

  pdata->checkbutton6 =
    gtk_check_button_new_with_mnemonic (_("Hiden network"));
  gtk_table_attach (GTK_TABLE (table2), pdata->checkbutton6, 0, 4, 9, 10,
		    (GtkAttachOptions) (GTK_FILL), (GtkAttachOptions) (0), 0,
		    0);
  gtk_widget_show (pdata->checkbutton6);
  gtk_tooltips_set_tip (pdata->tooltips, pdata->checkbutton6,
			_("Mark for hiden network"), NULL);
  GtkWidget * check =
    gtk_check_button_new_with_mnemonic (_("Show key"));
  gtk_table_attach (GTK_TABLE (table2), check, 0, 4, 10, 11,
		    (GtkAttachOptions) (GTK_FILL), (GtkAttachOptions) (0), 0,
		    0);
  gtk_widget_show (check);
  gtk_tooltips_set_tip (pdata->tooltips, check,
			_("Show or hide key network"), NULL);
  g_signal_connect ((gpointer) check, "toggled",
		    G_CALLBACK (togglednetkey), 
			GTK_OBJECT (pdata->entry_key));
	
  GtkWidget *net = gtk_label_new (_("Networks"));
  gtk_notebook_set_tab_label (GTK_NOTEBOOK (pdata->notebook1),
			      gtk_notebook_get_nth_page (GTK_NOTEBOOK
							 (pdata->notebook1),
							 num), net);
  
  gtk_widget_show (net);

}

void
zakl_ustawienia (int num)
{
//---------------------ustawienia--------------------------
  GtkWidget *scrolledwindow1 = gtk_scrolled_window_new (NULL, NULL);
  gtk_widget_show (scrolledwindow1);
  gtk_container_add (GTK_CONTAINER (pdata->notebook1), scrolledwindow1);
  gtk_container_set_border_width (GTK_CONTAINER (scrolledwindow1), 10);
  gtk_scrolled_window_set_policy (GTK_SCROLLED_WINDOW (scrolledwindow1),
				  GTK_POLICY_NEVER, GTK_POLICY_AUTOMATIC);

  GtkWidget *viewport1 = gtk_viewport_new (NULL, NULL);
  gtk_widget_show (viewport1);
  gtk_container_add (GTK_CONTAINER (scrolledwindow1), viewport1);


  GtkWidget *vbox_setting = gtk_vbox_new (FALSE, 5);
  gtk_container_add (GTK_CONTAINER (viewport1), vbox_setting);
  gtk_container_set_border_width (GTK_CONTAINER (vbox_setting), 10);
  gtk_widget_show (vbox_setting);

  GtkWidget *lab_iwconfig = gtk_label_new (_("Path to iwconfig"));
  gtk_box_pack_start (GTK_BOX (vbox_setting), lab_iwconfig, FALSE, FALSE, 0);
  gtk_widget_show (lab_iwconfig);

  GtkWidget *hbox_set_iwconfig = gtk_hbox_new (FALSE, 5);
  gtk_box_pack_start (GTK_BOX (vbox_setting), hbox_set_iwconfig, FALSE, FALSE,
		      0);
  gtk_widget_show (hbox_set_iwconfig);

  pdata->entry_set_iwconfig = gtk_entry_new ();
  gtk_box_pack_start (GTK_BOX (hbox_set_iwconfig), pdata->entry_set_iwconfig,
		      TRUE, TRUE, 0);
  gtk_widget_show (pdata->entry_set_iwconfig);

  GtkWidget *button_iwconfig = gtk_button_new_with_mnemonic (_("Browse"));
  gtk_box_pack_start (GTK_BOX (hbox_set_iwconfig), button_iwconfig, TRUE,
		      TRUE, 0);
  gtk_widget_show (button_iwconfig);
  g_signal_connect_swapped ((gpointer) button_iwconfig, "clicked",
			    G_CALLBACK (create_filechooserdialog1),
			    GTK_OBJECT (pdata->entry_set_iwconfig));
  gtk_tooltips_set_tip (pdata->tooltips, button_iwconfig, _("Find file"),
			NULL);

  GtkWidget *lab_iwlist = gtk_label_new (_("Path to iwlist"));
  gtk_box_pack_start (GTK_BOX (vbox_setting), lab_iwlist, FALSE, FALSE, 0);
  gtk_widget_show (lab_iwlist);

  GtkWidget *hbox_set_iwlist = gtk_hbox_new (FALSE, 5);
  gtk_box_pack_start (GTK_BOX (vbox_setting), hbox_set_iwlist, FALSE, FALSE,
		      0);
  gtk_widget_show (hbox_set_iwlist);

  pdata->entry_set_iwlist = gtk_entry_new ();
  gtk_box_pack_start (GTK_BOX (hbox_set_iwlist), pdata->entry_set_iwlist,
		      TRUE, TRUE, 0);
  gtk_widget_show (pdata->entry_set_iwlist);

  GtkWidget *button_iwlist = gtk_button_new_with_mnemonic (_("Browse"));
  gtk_box_pack_start (GTK_BOX (hbox_set_iwlist), button_iwlist, TRUE, TRUE,
		      0);
  gtk_widget_show (button_iwlist);
  g_signal_connect_swapped ((gpointer) button_iwlist, "clicked",
			    G_CALLBACK (create_filechooserdialog1),
			    GTK_OBJECT (pdata->entry_set_iwlist));
  gtk_tooltips_set_tip (pdata->tooltips, button_iwlist, _("Find file"), NULL);
//===========================================
  GtkWidget *lab_iwpriv = gtk_label_new (_("Path to iwpriv"));
  gtk_box_pack_start (GTK_BOX (vbox_setting), lab_iwpriv, FALSE, FALSE, 0);
  gtk_widget_show (lab_iwpriv);

  GtkWidget *hbox_set_iwpriv = gtk_hbox_new (FALSE, 5);
  gtk_box_pack_start (GTK_BOX (vbox_setting), hbox_set_iwpriv, FALSE, FALSE,
		      0);
  gtk_widget_show (hbox_set_iwpriv);

  pdata->entry_set_iwpriv = gtk_entry_new ();
  gtk_box_pack_start (GTK_BOX (hbox_set_iwpriv), pdata->entry_set_iwpriv,
		      TRUE, TRUE, 0);
  gtk_widget_show (pdata->entry_set_iwpriv);

  GtkWidget *button_iwpriv = gtk_button_new_with_mnemonic (_("Browse"));
  gtk_box_pack_start (GTK_BOX (hbox_set_iwpriv), button_iwpriv, TRUE, TRUE,
		      0);
  gtk_widget_show (button_iwpriv);
  g_signal_connect_swapped ((gpointer) button_iwlist, "clicked",
			    G_CALLBACK (create_filechooserdialog1),
			    GTK_OBJECT (pdata->entry_set_iwpriv));
  gtk_tooltips_set_tip (pdata->tooltips, button_iwpriv, _("Find file"), NULL);
//===========================================
  GtkWidget *lab_ifconfig = gtk_label_new (_("Path to ifconfig"));
  gtk_box_pack_start (GTK_BOX (vbox_setting), lab_ifconfig, FALSE, FALSE, 0);
  gtk_widget_show (lab_ifconfig);

  GtkWidget *hbox_set_ifconfig = gtk_hbox_new (FALSE, 5);
  gtk_box_pack_start (GTK_BOX (vbox_setting), hbox_set_ifconfig, FALSE, FALSE,
		      0);
  gtk_widget_show (hbox_set_ifconfig);

  pdata->entry_set_ifconfig = gtk_entry_new ();
  gtk_box_pack_start (GTK_BOX (hbox_set_ifconfig), pdata->entry_set_ifconfig,
		      TRUE, TRUE, 0);
  gtk_widget_show (pdata->entry_set_ifconfig);

  GtkWidget *button_ifconfig = gtk_button_new_with_mnemonic (_("Browse"));
  gtk_box_pack_start (GTK_BOX (hbox_set_ifconfig), button_ifconfig, TRUE,
		      TRUE, 0);
  gtk_widget_show (button_ifconfig);
  g_signal_connect_swapped ((gpointer) button_ifconfig, "clicked",
			    G_CALLBACK (create_filechooserdialog1),
			    GTK_OBJECT (pdata->entry_set_ifconfig));
  gtk_tooltips_set_tip (pdata->tooltips, button_ifconfig, _("Find file"),
			NULL);

  GtkWidget *lab_route = gtk_label_new (_("Path to route"));
  gtk_box_pack_start (GTK_BOX (vbox_setting), lab_route, FALSE, FALSE, 0);
  gtk_widget_show (lab_route);

  GtkWidget *hbox_set_route = gtk_hbox_new (FALSE, 5);
  gtk_box_pack_start (GTK_BOX (vbox_setting), hbox_set_route, FALSE, FALSE,
		      0);
  gtk_widget_show (hbox_set_route);

  pdata->entry_set_route = gtk_entry_new ();
  gtk_box_pack_start (GTK_BOX (hbox_set_route), pdata->entry_set_route, TRUE,
		      TRUE, 0);
  gtk_widget_show (pdata->entry_set_route);

  GtkWidget *button_route = gtk_button_new_with_mnemonic (_("Browse"));
  gtk_box_pack_start (GTK_BOX (hbox_set_route), button_route, TRUE, TRUE, 0);
  gtk_widget_show (button_route);
  g_signal_connect_swapped ((gpointer) button_route, "clicked",
			    G_CALLBACK (create_filechooserdialog1),
			    GTK_OBJECT (pdata->entry_set_route));
  gtk_tooltips_set_tip (pdata->tooltips, button_route, _("Find file"), NULL);

  GtkWidget *lab_dhcp = gtk_label_new (_("Path to DHCP client"));
  gtk_box_pack_start (GTK_BOX (vbox_setting), lab_dhcp, FALSE, FALSE, 0);
  gtk_widget_show (lab_dhcp);

  GtkWidget *hbox_set_dhcp = gtk_hbox_new (FALSE, 5);
  gtk_box_pack_start (GTK_BOX (vbox_setting), hbox_set_dhcp, FALSE, FALSE, 0);
  gtk_widget_show (hbox_set_dhcp);

  pdata->entry_set_dhcp = gtk_entry_new ();
  gtk_box_pack_start (GTK_BOX (hbox_set_dhcp), pdata->entry_set_dhcp, TRUE,
		      TRUE, 0);
  gtk_widget_show (pdata->entry_set_dhcp);

  GtkWidget *button_dhcp = gtk_button_new_with_mnemonic (_("Browse"));
  gtk_box_pack_start (GTK_BOX (hbox_set_dhcp), button_dhcp, TRUE, TRUE, 0);
  gtk_widget_show (button_dhcp);
  g_signal_connect_swapped ((gpointer) button_dhcp, "clicked",
			    G_CALLBACK (create_filechooserdialog1),
			    GTK_OBJECT (pdata->entry_set_dhcp));
  gtk_tooltips_set_tip (pdata->tooltips, button_dhcp, _("Find file"), NULL);
//su
  GtkWidget *lab_su = gtk_label_new (_("Path to su"));	//78
  gtk_box_pack_start (GTK_BOX (vbox_setting), lab_su, FALSE, FALSE, 0);
  gtk_widget_show (lab_su);

  GtkWidget *hbox_set_su = gtk_hbox_new (FALSE, 0);
  gtk_box_pack_start (GTK_BOX (vbox_setting), hbox_set_su, FALSE, FALSE, 0);
  gtk_widget_show (hbox_set_su);

  pdata->entry_set_su = gtk_entry_new ();
  gtk_box_pack_start (GTK_BOX (hbox_set_su), pdata->entry_set_su, TRUE, TRUE,
		      0);
  gtk_widget_show (pdata->entry_set_su);

  GtkWidget *button_su = gtk_button_new_with_mnemonic (_("Browse"));	//39
  gtk_box_pack_start (GTK_BOX (hbox_set_su), button_su, TRUE, TRUE, 0);
  gtk_widget_show (button_su);
  g_signal_connect_swapped ((gpointer) button_su, "clicked",
			    G_CALLBACK (create_filechooserdialog1),
			    GTK_OBJECT (pdata->entry_set_su));
  gtk_tooltips_set_tip (pdata->tooltips, button_su, _("Find file"), NULL);	//40
//sudo
  GtkWidget *lab_sudo = gtk_label_new (_("Path to sudo"));	//78
  gtk_box_pack_start (GTK_BOX (vbox_setting), lab_sudo, FALSE, FALSE, 0);
  gtk_widget_show (lab_sudo);

  GtkWidget *hbox_set_sudo = gtk_hbox_new (FALSE, 0);
  gtk_box_pack_start (GTK_BOX (vbox_setting), hbox_set_sudo, FALSE, FALSE, 0);
  gtk_widget_show (hbox_set_sudo);

  pdata->entry_set_sudo = gtk_entry_new ();
  gtk_box_pack_start (GTK_BOX (hbox_set_sudo), pdata->entry_set_sudo, TRUE,
		      TRUE, 0);
  gtk_widget_show (pdata->entry_set_sudo);

  GtkWidget *button_sudo = gtk_button_new_with_mnemonic (_("Browse"));	//39
  gtk_box_pack_start (GTK_BOX (hbox_set_sudo), button_sudo, TRUE, TRUE, 0);
  gtk_widget_show (button_sudo);
  g_signal_connect_swapped ((gpointer) button_sudo, "clicked",
			    G_CALLBACK (create_filechooserdialog1),
			    GTK_OBJECT (pdata->entry_set_sudo));
  gtk_tooltips_set_tip (pdata->tooltips, button_sudo, _("Find file"), NULL);	//40
//wpa_supp
  GtkWidget *lab_wpa_supp = gtk_label_new (_("Path to wpa_supplicant"));	//76
  gtk_box_pack_start (GTK_BOX (vbox_setting), lab_wpa_supp, FALSE, FALSE, 0);
  gtk_widget_show (lab_wpa_supp);

  GtkWidget *hbox_set_wpa_supp = gtk_hbox_new (FALSE, 0);
  gtk_box_pack_start (GTK_BOX (vbox_setting), hbox_set_wpa_supp, FALSE, FALSE,
		      0);
  gtk_widget_show (hbox_set_wpa_supp);

  pdata->entry_set_wpa_supp = gtk_entry_new ();
  gtk_box_pack_start (GTK_BOX (hbox_set_wpa_supp), pdata->entry_set_wpa_supp,
		      TRUE, TRUE, 0);
  gtk_widget_show (pdata->entry_set_wpa_supp);

  GtkWidget *button_wpa_supp = gtk_button_new_with_mnemonic (_("Browse"));	//39
  gtk_box_pack_start (GTK_BOX (hbox_set_wpa_supp), button_wpa_supp, TRUE,
		      TRUE, 0);
  gtk_widget_show (button_wpa_supp);
  g_signal_connect_swapped ((gpointer) button_wpa_supp, "clicked",
			    G_CALLBACK (create_filechooserdialog1),
			    GTK_OBJECT (pdata->entry_set_wpa_supp));
  gtk_tooltips_set_tip (pdata->tooltips, button_wpa_supp, _("Find file"), NULL);	//40
//wpa_cli
  GtkWidget *lab_wpa_cli = gtk_label_new (_("Path to wpa_cli"));	//77
  gtk_box_pack_start (GTK_BOX (vbox_setting), lab_wpa_cli, FALSE, FALSE, 0);
  gtk_widget_show (lab_wpa_cli);

  GtkWidget *hbox_set_wpa_cli = gtk_hbox_new (FALSE, 0);
  gtk_box_pack_start (GTK_BOX (vbox_setting), hbox_set_wpa_cli, FALSE, FALSE,
		      0);
  gtk_widget_show (hbox_set_wpa_cli);

  pdata->entry_set_wpa_cli = gtk_entry_new ();
  gtk_box_pack_start (GTK_BOX (hbox_set_wpa_cli), pdata->entry_set_wpa_cli,
		      TRUE, TRUE, 0);
  gtk_widget_show (pdata->entry_set_wpa_cli);

  GtkWidget *button_wpa_cli = gtk_button_new_with_mnemonic (_("Browse"));	//39
  gtk_box_pack_start (GTK_BOX (hbox_set_wpa_cli), button_wpa_cli, TRUE, TRUE,
		      0);
  gtk_widget_show (button_wpa_cli);
  g_signal_connect_swapped ((gpointer) button_wpa_cli, "clicked",
			    G_CALLBACK (create_filechooserdialog1),
			    GTK_OBJECT (pdata->entry_set_wpa_cli));
  gtk_tooltips_set_tip (pdata->tooltips, button_wpa_cli, _("Find file"), NULL);	//40
//wpa_pas
  GtkWidget *lab_wpa_pas = gtk_label_new (_("Path to wpa_passphrase"));	//78
  gtk_box_pack_start (GTK_BOX (vbox_setting), lab_wpa_pas, FALSE, FALSE, 0);
  gtk_widget_show (lab_wpa_pas);

  GtkWidget *hbox_set_wpa_pas = gtk_hbox_new (FALSE, 0);
  gtk_box_pack_start (GTK_BOX (vbox_setting), hbox_set_wpa_pas, FALSE, FALSE,
		      0);
  gtk_widget_show (hbox_set_wpa_pas);

  pdata->entry_set_wpa_pas = gtk_entry_new ();
  gtk_box_pack_start (GTK_BOX (hbox_set_wpa_pas), pdata->entry_set_wpa_pas,
		      TRUE, TRUE, 0);
  gtk_widget_show (pdata->entry_set_wpa_pas);

  GtkWidget *button_wpa_pas = gtk_button_new_with_mnemonic (_("Browse"));	//39
  gtk_box_pack_start (GTK_BOX (hbox_set_wpa_pas), button_wpa_pas, TRUE, TRUE,
		      0);
  gtk_widget_show (button_wpa_pas);
  g_signal_connect_swapped ((gpointer) button_wpa_pas, "clicked",
			    G_CALLBACK (create_filechooserdialog1),
			    GTK_OBJECT (pdata->entry_set_wpa_pas));
  gtk_tooltips_set_tip (pdata->tooltips, button_wpa_pas, _("Find file"), NULL);	//40
//wpa_ctrl
  GtkWidget *hbox_set_wpa_ctrl1 = gtk_hbox_new (FALSE, 0);
  gtk_box_pack_start (GTK_BOX (vbox_setting), hbox_set_wpa_ctrl1, FALSE,
		      FALSE, 0);
  gtk_widget_show (hbox_set_wpa_ctrl1);

  GtkWidget *lab_wpa_ctrl = gtk_label_new (_("Path to ctrl_interface"));	//79
  gtk_box_pack_start (GTK_BOX (hbox_set_wpa_ctrl1), lab_wpa_ctrl, TRUE, TRUE,
		      0);
  gtk_widget_show (lab_wpa_ctrl);

  GtkWidget *lab_wpa_ctrl1 = gtk_label_new (_("driver wpa_supplicant"));	//99
  gtk_box_pack_start (GTK_BOX (hbox_set_wpa_ctrl1), lab_wpa_ctrl1, TRUE, TRUE,
		      0);
  gtk_widget_show (lab_wpa_ctrl1);

  GtkWidget *hbox_set_wpa_ctrl = gtk_hbox_new (FALSE, 0);
  gtk_box_pack_start (GTK_BOX (vbox_setting), hbox_set_wpa_ctrl, FALSE, FALSE,
		      0);
  gtk_widget_show (hbox_set_wpa_ctrl);

  pdata->entry_set_wpa_ctrl = gtk_entry_new ();
  gtk_box_pack_start (GTK_BOX (hbox_set_wpa_ctrl), pdata->entry_set_wpa_ctrl,
		      TRUE, TRUE, 0);
  gtk_widget_show (pdata->entry_set_wpa_ctrl);


  pdata->comboboxentry_wpa_ctrl = gtk_combo_box_entry_new_text ();
  gtk_box_pack_start (GTK_BOX (hbox_set_wpa_ctrl),
		      pdata->comboboxentry_wpa_ctrl, TRUE, TRUE, 0);
  gtk_widget_show (pdata->comboboxentry_wpa_ctrl);
  gtk_combo_box_append_text (GTK_COMBO_BOX (pdata->comboboxentry_wpa_ctrl),
			     "hostap");
  gtk_combo_box_append_text (GTK_COMBO_BOX (pdata->comboboxentry_wpa_ctrl),
			     "madwifi");
  gtk_combo_box_append_text (GTK_COMBO_BOX (pdata->comboboxentry_wpa_ctrl),
			     "atmel");
  gtk_combo_box_append_text (GTK_COMBO_BOX (pdata->comboboxentry_wpa_ctrl),
			     "wext");
  gtk_combo_box_append_text (GTK_COMBO_BOX (pdata->comboboxentry_wpa_ctrl),
			     "ndiswrapper");
  gtk_combo_box_append_text (GTK_COMBO_BOX (pdata->comboboxentry_wpa_ctrl),
			     "ipw");
  gtk_combo_box_append_text (GTK_COMBO_BOX (pdata->comboboxentry_wpa_ctrl),
			     "wired");
  gtk_combo_box_append_text (GTK_COMBO_BOX (pdata->comboboxentry_wpa_ctrl),
			     "test");
//wpa cfg
  GtkWidget *lab_wpa_cfg = gtk_label_new (_("Path to wpa_supplicant config"));	//98
  gtk_box_pack_start (GTK_BOX (vbox_setting), lab_wpa_cfg, FALSE, FALSE, 0);
  gtk_widget_show (lab_wpa_cfg);

  pdata->entry_set_wpa_cfg = gtk_entry_new ();
  gtk_box_pack_start (GTK_BOX (vbox_setting), pdata->entry_set_wpa_cfg, FALSE,
		      FALSE, 0);
  gtk_widget_show (pdata->entry_set_wpa_cfg);
//
  GtkWidget *hbox_set1 = gtk_hbox_new (FALSE, 5);
  gtk_box_pack_start (GTK_BOX (vbox_setting), hbox_set1, FALSE, FALSE, 0);
  gtk_widget_show (hbox_set1);

  GtkWidget *lab_set4 = gtk_label_new (_("iwconfig time"));
  gtk_box_pack_start (GTK_BOX (hbox_set1), lab_set4, FALSE, FALSE, 0);
  gtk_widget_show (lab_set4);

  GtkWidget *lab_set41 = gtk_label_new (_("WiFi interface"));
  gtk_box_pack_start (GTK_BOX (hbox_set1), lab_set41, TRUE, TRUE, 0);
  gtk_widget_show (lab_set41);

  GtkWidget *hbox_tme = gtk_hbox_new (FALSE, 5);
  gtk_box_pack_start (GTK_BOX (vbox_setting), hbox_tme, FALSE, FALSE, 0);
  gtk_widget_show (hbox_tme);

  GtkObject *spinbutton4_adj = gtk_adjustment_new (5, 1, 10, 1, 10, 10);
  pdata->entry_set_timescan =
    gtk_spin_button_new (GTK_ADJUSTMENT (spinbutton4_adj), 1, 0);
  gtk_widget_show (pdata->entry_set_timescan);
  gtk_box_pack_start (GTK_BOX (hbox_tme), pdata->entry_set_timescan, TRUE,
		      TRUE, 0);
  gtk_spin_button_set_numeric (GTK_SPIN_BUTTON (pdata->entry_set_timescan),
			       TRUE);

  pdata->entry_set_inter = gtk_entry_new ();
  gtk_box_pack_start (GTK_BOX (hbox_tme), pdata->entry_set_inter, FALSE,
		      FALSE, 0);
  gtk_widget_show (pdata->entry_set_inter);

  GtkWidget *button_set_inter = gtk_button_new_with_mnemonic (_("Apply"));
  gtk_box_pack_start (GTK_BOX (hbox_tme), button_set_inter, TRUE, TRUE, 0);
  gtk_tooltips_set_tip (pdata->tooltips, button_set_inter,
			_("Activate specified interface. Type in \"auto\" "
			  "to have GwifiMeter automatically detect it. "),
			NULL);
  gtk_widget_show (button_set_inter);
  gtk_widget_set_size_request (button_set_inter, 105, -1);
  g_signal_connect (G_OBJECT (button_set_inter), "clicked",
		    G_CALLBACK (findfaceset), NULL);
//======
  GtkWidget *hbox_set3 = gtk_hbox_new (FALSE, 5);
  gtk_box_pack_start (GTK_BOX (vbox_setting), hbox_set3, FALSE, FALSE, 0);
  gtk_widget_show (hbox_set3);

  GtkWidget *lab_set5 = gtk_label_new (_("time connect"));
  gtk_box_pack_start (GTK_BOX (hbox_set3), lab_set5, FALSE, FALSE, 0);
  gtk_widget_show (lab_set5);

  GtkWidget *lab_set51 = gtk_label_new (_("time check"));
  gtk_box_pack_start (GTK_BOX (hbox_set3), lab_set51, TRUE, TRUE, 0);
  gtk_widget_show (lab_set51);

  GtkWidget *lab_set52 = gtk_label_new (_("Mode WPA"));
  gtk_box_pack_start (GTK_BOX (hbox_set3), lab_set52, TRUE, TRUE, 0);
  gtk_widget_show (lab_set52);

  GtkWidget *hbox_set5 = gtk_hbox_new (FALSE, 5);
  gtk_box_pack_start (GTK_BOX (vbox_setting), hbox_set5, FALSE, FALSE, 0);
  gtk_widget_show (hbox_set5);

  GtkObject *spinbutton_con_adj = gtk_adjustment_new (10, 1, 59, 1, 10, 10);
  pdata->entry_set_time_to_con =
    gtk_spin_button_new (GTK_ADJUSTMENT (spinbutton_con_adj), 1, 0);
  gtk_widget_show (pdata->entry_set_time_to_con);
  gtk_box_pack_start (GTK_BOX (hbox_set5), pdata->entry_set_time_to_con, TRUE,
		      TRUE, 0);
  gtk_spin_button_set_numeric (GTK_SPIN_BUTTON (pdata->entry_set_time_to_con),
			       TRUE);

  GtkObject *spinbutton_con_adj1 = gtk_adjustment_new (5, 1, 10, 1, 10, 10);
  pdata->entry_set_time_to_con1 =
    gtk_spin_button_new (GTK_ADJUSTMENT (spinbutton_con_adj1), 1, 0);
  gtk_widget_show (pdata->entry_set_time_to_con1);
  gtk_box_pack_start (GTK_BOX (hbox_set5), pdata->entry_set_time_to_con1,
		      TRUE, TRUE, 0);
  gtk_spin_button_set_numeric (GTK_SPIN_BUTTON
			       (pdata->entry_set_time_to_con1), TRUE);

  pdata->comboboxentry_wpa_mode = gtk_combo_box_new_text ();
  gtk_box_pack_start (GTK_BOX (hbox_set5), pdata->comboboxentry_wpa_mode,
		      TRUE, TRUE, 0);
  gtk_widget_show (pdata->comboboxentry_wpa_mode);
  gtk_combo_box_append_text (GTK_COMBO_BOX (pdata->comboboxentry_wpa_mode),
			     "auto");
  gtk_combo_box_append_text (GTK_COMBO_BOX (pdata->comboboxentry_wpa_mode),
			     "wpasupplicant");
  gtk_combo_box_append_text (GTK_COMBO_BOX (pdata->comboboxentry_wpa_mode),
			     "iwpriv(ralink)");
//======

  GtkWidget *table2 = gtk_table_new (6, 4, TRUE);
  gtk_widget_show (table2);
  gtk_container_add (GTK_CONTAINER (vbox_setting), table2);
  gtk_container_set_border_width (GTK_CONTAINER (table2), 5);
  gtk_widget_show (table2);

  pdata->checkbutton1 =
    gtk_check_button_new_with_mnemonic (_("Systray icon"));
  gtk_table_attach (GTK_TABLE (table2), pdata->checkbutton1, 0, 2, 0, 1,
		    (GtkAttachOptions) (GTK_EXPAND | GTK_FILL),
		    (GtkAttachOptions) (GTK_EXPAND | GTK_FILL), 0, 0);
  gtk_widget_show (pdata->checkbutton1);
  gtk_tooltips_set_tip (pdata->tooltips, pdata->checkbutton1,
			_("Put an icon into systray"), NULL);
  g_signal_connect ((gpointer) pdata->checkbutton1, "toggled",
		    G_CALLBACK (toggled1), NULL);

  pdata->checkbutton3 =
    gtk_check_button_new_with_mnemonic (_("Dock on startup"));
  gtk_table_attach (GTK_TABLE (table2), pdata->checkbutton3, 2, 4, 0, 1,
		    (GtkAttachOptions) (GTK_FILL),
		    (GtkAttachOptions) (GTK_EXPAND | GTK_FILL), 0, 0);
  gtk_widget_show (pdata->checkbutton3);
  gtk_tooltips_set_tip (pdata->tooltips, pdata->checkbutton3,
			_("Dock programme  on startup."), NULL);
  g_signal_connect ((gpointer) pdata->checkbutton3, "toggled",
		    G_CALLBACK (toggled3), NULL);

  pdata->checkbutton4 = gtk_check_button_new_with_mnemonic (_("Use sudo"));
  gtk_table_attach (GTK_TABLE (table2), pdata->checkbutton4, 0, 2, 1, 2,
		    (GtkAttachOptions) (GTK_FILL),
		    (GtkAttachOptions) (0), 0, 0);
  gtk_widget_show (pdata->checkbutton4);
  gtk_tooltips_set_tip (pdata->tooltips, pdata->checkbutton4,
			_("Use sudo to connect."), NULL);
  g_signal_connect ((gpointer) pdata->checkbutton4, "toggled",
		    G_CALLBACK (toggled4), NULL);

  pdata->checkbutton11 =
    gtk_check_button_new_with_mnemonic (_("Use su"));
  gtk_table_attach (GTK_TABLE (table2), pdata->checkbutton11, 0, 2, 2, 3,
		    (GtkAttachOptions) (GTK_FILL), (GtkAttachOptions) (0), 0,
		    0);
  gtk_widget_show (pdata->checkbutton11);
  gtk_tooltips_set_tip (pdata->tooltips, pdata->checkbutton11,
						_("Use su to connects."), NULL);
  g_signal_connect ((gpointer) pdata->checkbutton11, "toggled",
		    G_CALLBACK (toggled11), NULL);

  pdata->checkbutton8 =
    gtk_check_button_new_with_mnemonic (_("Simple connect"));
  gtk_table_attach (GTK_TABLE (table2), pdata->checkbutton8, 2, 4, 1, 2,
		    (GtkAttachOptions) (GTK_FILL), (GtkAttachOptions) (0), 0,
		    0);
  gtk_widget_show (pdata->checkbutton8);
  gtk_tooltips_set_tip (pdata->tooltips, pdata->checkbutton8,
			_("Use simple connect metode."), NULL);

  pdata->checkbutton9 =
    gtk_check_button_new_with_mnemonic (_("Save password"));
  gtk_table_attach (GTK_TABLE (table2), pdata->checkbutton9, 0, 2, 3, 4,
		    (GtkAttachOptions) (GTK_FILL), (GtkAttachOptions) (0), 0,
		    0);
  gtk_widget_show (pdata->checkbutton9);
  gtk_tooltips_set_tip (pdata->tooltips, pdata->checkbutton9,
			_("This function is not safe."), NULL);

  pdata->checkbutton10 =
    gtk_check_button_new_with_mnemonic (_("Runing if system startup"));
  gtk_table_attach (GTK_TABLE (table2), pdata->checkbutton10, 2, 4, 2, 3,
		    (GtkAttachOptions) (GTK_FILL), (GtkAttachOptions) (0), 0,
		    0);
  gtk_widget_show (pdata->checkbutton10);
  gtk_tooltips_set_tip (pdata->tooltips, pdata->checkbutton10,
			_("Runing program if Gnome or KDE startup."), NULL);
	


  //=========================================
  GtkWidget *label_wlasny1 = gtk_label_new (_("Icon theme"));
  gtk_table_attach (GTK_TABLE (table2), label_wlasny1, 0, 2, 4, 5,
		    (GtkAttachOptions) (GTK_EXPAND | GTK_FILL),
		    (GtkAttachOptions) (GTK_EXPAND | GTK_FILL), 0, 0);
  gtk_widget_show (label_wlasny1);

  GtkWidget *label_wlasny2 = gtk_label_new (_("Theme"));
  gtk_table_attach (GTK_TABLE (table2), label_wlasny2, 2, 4, 4, 5,
		    (GtkAttachOptions) (GTK_FILL),
		    (GtkAttachOptions) (GTK_EXPAND | GTK_FILL), 0, 0);
  gtk_widget_show (label_wlasny2);

  pdata->comboboxentry_icon = gtk_combo_box_new_text ();
  gtk_table_attach (GTK_TABLE (table2), pdata->comboboxentry_icon, 0, 2, 5, 6,
		    (GtkAttachOptions) (GTK_FILL),
		    (GtkAttachOptions) (0), 0, 0);
  gtk_combo_box_append_text (GTK_COMBO_BOX (pdata->comboboxentry_icon),
			     "default");
  gtk_widget_show (pdata->comboboxentry_icon);

  pdata->comboboxentry_theme = gtk_combo_box_new_text ();
  gtk_table_attach (GTK_TABLE (table2), pdata->comboboxentry_theme, 2, 4, 5,
		    6, (GtkAttachOptions) (GTK_FILL), (GtkAttachOptions) (0),
		    0, 0);
  gtk_combo_box_append_text (GTK_COMBO_BOX (pdata->comboboxentry_theme),
			     _("system"));
  gtk_widget_show (pdata->comboboxentry_theme);
  //===========================================
  GtkWidget *label =
    gtk_label_new (_("Colour of the systray icon depening on signal level"));
  gtk_table_attach (GTK_TABLE (table2), label, 0, 4, 6, 7,
		    (GtkAttachOptions) (GTK_FILL), (GtkAttachOptions) (0), 0,
		    0);
  gtk_widget_show (label);

  GtkWidget *hbox7 = gtk_hbox_new (FALSE, 5);
  gtk_table_attach (GTK_TABLE (table2), hbox7, 0, 4, 7, 8,
		    (GtkAttachOptions) (GTK_FILL),
		    (GtkAttachOptions) (0), 0, 0);
  gtk_widget_show (hbox7);

  GtkWidget *label31 = gtk_label_new (_("red >"));
  gtk_widget_show (label31);
  gtk_box_pack_start (GTK_BOX (hbox7), label31, FALSE, FALSE, 0);

  GtkObject *spinbutton1_adj = gtk_adjustment_new (30, 1, 98, 1, 10, 10);
  pdata->spinbutton1 =
    gtk_spin_button_new (GTK_ADJUSTMENT (spinbutton1_adj), 1, 0);
  gtk_widget_show (pdata->spinbutton1);
  gtk_box_pack_start (GTK_BOX (hbox7), pdata->spinbutton1, TRUE, TRUE, 0);
  gtk_spin_button_set_numeric (GTK_SPIN_BUTTON (pdata->spinbutton1), TRUE);
  g_signal_connect ((gpointer) pdata->spinbutton1, "value_changed",
		    G_CALLBACK (on_spinbutton1_value_changed), NULL);
  gtk_widget_set_size_request (pdata->spinbutton1, 40, -1);

  GtkWidget *label36 = gtk_label_new (_("< blue >"));
  gtk_widget_show (label36);
  gtk_box_pack_start (GTK_BOX (hbox7), label36, FALSE, FALSE, 0);

  GtkObject *spinbutton5_adj = gtk_adjustment_new (50, 2, 99, 1, 10, 10);
  pdata->spinbutton5 =
    gtk_spin_button_new (GTK_ADJUSTMENT (spinbutton5_adj), 1, 0);
  gtk_widget_show (pdata->spinbutton5);
  gtk_box_pack_start (GTK_BOX (hbox7), pdata->spinbutton5, TRUE, TRUE, 0);
  gtk_spin_button_set_numeric (GTK_SPIN_BUTTON (pdata->spinbutton5), TRUE);
  g_signal_connect ((gpointer) pdata->spinbutton5, "value_changed",
		    G_CALLBACK (on_spinbutton5_value_changed), NULL);
  gtk_widget_set_size_request (pdata->spinbutton5, 40, -1);

  GtkWidget *label32 = gtk_label_new (_("< yellow >"));
  gtk_widget_show (label32);
  gtk_box_pack_start (GTK_BOX (hbox7), label32, FALSE, FALSE, 0);

  GtkObject *spinbutton2_adj = gtk_adjustment_new (70, 3, 100, 1, 10, 10);
  pdata->spinbutton2 =
    gtk_spin_button_new (GTK_ADJUSTMENT (spinbutton2_adj), 1, 0);
  gtk_widget_show (pdata->spinbutton2);
  gtk_box_pack_start (GTK_BOX (hbox7), pdata->spinbutton2, TRUE, TRUE, 0);
  gtk_spin_button_set_numeric (GTK_SPIN_BUTTON (pdata->spinbutton2), TRUE);
  g_signal_connect ((gpointer) pdata->spinbutton2, "value_changed",
		    G_CALLBACK (on_spinbutton2_value_changed), NULL);
  gtk_widget_set_size_request (pdata->spinbutton2, 40, -1);

  GtkWidget *label33 = gtk_label_new (_("< green"));
  gtk_widget_show (label33);
  gtk_box_pack_start (GTK_BOX (hbox7), label33, FALSE, FALSE, 0);

  GtkWidget *label_null = gtk_label_new ("");
  gtk_widget_show (label_null);
  gtk_box_pack_start (GTK_BOX (vbox_setting), label_null, FALSE, FALSE, 0);

  GtkWidget *hbox8 = gtk_hbox_new (FALSE, 5);
  gtk_widget_show (hbox8);
  gtk_box_pack_start (GTK_BOX (vbox_setting), hbox8, TRUE, TRUE, 0);

  GtkWidget *label34 = gtk_label_new (_("Max progress at "));
  gtk_widget_show (label34);
  gtk_box_pack_start (GTK_BOX (hbox8), label34, FALSE, FALSE, 0);

  GtkObject *spinbutton3_adj = gtk_adjustment_new (70, 1, 100, 1, 10, 10);
  pdata->spinbutton3 =
    gtk_spin_button_new (GTK_ADJUSTMENT (spinbutton3_adj), 1, 0);
  gtk_widget_show (pdata->spinbutton3);
  gtk_box_pack_start (GTK_BOX (hbox8), pdata->spinbutton3, TRUE, TRUE, 0);
  gtk_spin_button_set_numeric (GTK_SPIN_BUTTON (pdata->spinbutton3), TRUE);
  gtk_widget_set_size_request (pdata->spinbutton3, 40, -1);

  GtkWidget *label35 = gtk_label_new (_("% signal."));
  gtk_widget_show (label35);
  gtk_box_pack_start (GTK_BOX (hbox8), label35, FALSE, FALSE, 0);


  GtkWidget *hbox_set2 = gtk_hbox_new (FALSE, 5);
  gtk_box_pack_start (GTK_BOX (vbox_setting), hbox_set2, FALSE, FALSE, 0);
  gtk_widget_show (hbox_set2);

  GtkWidget *button_save = gtk_button_new_with_mnemonic (_("Save"));
  gtk_box_pack_start (GTK_BOX (hbox_set2), button_save, TRUE, TRUE, 0);
  gtk_tooltips_set_tip (pdata->tooltips, button_save, _("Save settings"),
			NULL);
  gtk_widget_show (button_save);
  g_signal_connect (G_OBJECT (button_save), "clicked", G_CALLBACK (savepass),
		    NULL);

  GtkWidget *button_default = gtk_button_new_with_mnemonic (_("Default"));
  gtk_box_pack_start (GTK_BOX (hbox_set2), button_default, TRUE, TRUE, 0);
  gtk_tooltips_set_tip (pdata->tooltips, button_default,
			_("Set default parameters."), NULL);
  gtk_widget_show (button_default);
  g_signal_connect (G_OBJECT (button_default), "clicked",
		    G_CALLBACK (defaultset), NULL);

  GtkWidget *zakl_setting = gtk_label_new (_("Settings"));
  gtk_notebook_set_tab_label (GTK_NOTEBOOK (pdata->notebook1),
			      gtk_notebook_get_nth_page (GTK_NOTEBOOK
							 (pdata->notebook1),
							 num), zakl_setting);
  gtk_widget_show (zakl_setting);
}

void
zakl_o (int num)
{
//---------------------zakladka o--------------------------
  GtkWidget *vbox4 = gtk_vbox_new (FALSE, 0);
  gtk_container_add (GTK_CONTAINER (pdata->notebook1), vbox4);
  gtk_widget_show (vbox4);
  gtk_container_set_border_width (GTK_CONTAINER (vbox4), 10);
  GtkWidget *info =
    gtk_label_new (_
		   ("Gwifieter 0.6.0\nCreated by Adam Strzalkowski\n e-mail : gosad@op.pl\nwww.gwifimeter.republika.pl"));
  gtk_label_set_justify (GTK_LABEL (info), GTK_JUSTIFY_CENTER);
  gtk_widget_show (info);
  gtk_container_add (GTK_CONTAINER (vbox4), info);
  GtkWidget *zakl_o = gtk_label_new (_("About"));
  gtk_notebook_set_tab_label (GTK_NOTEBOOK (pdata->notebook1),
			      gtk_notebook_get_nth_page (GTK_NOTEBOOK
							 (pdata->notebook1),
							 num), zakl_o);
  gtk_widget_show (zakl_o);
}

//===========================================================
GtkWidget *
passave (void)
{
  GtkWidget *window_pas;
  GtkWidget *vbox_pas;
  GtkWidget *lab_pas;
  GtkWidget *entry_pas;
  GtkWidget *button_pas;
  GtkWidget *hbox_pas;
  GtkWidget *button_pas_cancel;



//----------------------------------------------------------
  window_pas = gtk_window_new (GTK_WINDOW_TOPLEVEL);
  gtk_window_set_modal (GTK_WINDOW (window_pas), TRUE);
  gtk_window_set_type_hint (GTK_WINDOW (window_pas),
			    GDK_WINDOW_TYPE_HINT_DIALOG);
  gtk_widget_set_size_request (window_pas, 200, 130);
  gtk_window_set_title (GTK_WINDOW (window_pas), (_("Password")));	//73
  gtk_container_set_border_width (GTK_CONTAINER (window_pas), 10);
  vbox_pas = gtk_vbox_new (FALSE, 0);
  gtk_container_add (GTK_CONTAINER (window_pas), vbox_pas);
  gtk_container_set_border_width (GTK_CONTAINER (vbox_pas), 10);
  if (gtk_toggle_button_get_active (GTK_TOGGLE_BUTTON (pdata->checkbutton4)))
    {
      lab_pas = gtk_label_new (_("Your password"));
    }
  else
    {
      lab_pas = gtk_label_new (_("Root password"));
    }

  gtk_label_set_justify (GTK_LABEL (lab_pas), GTK_JUSTIFY_CENTER);
  gtk_box_pack_start (GTK_BOX (vbox_pas), lab_pas, TRUE, TRUE, 0);
  entry_pas = gtk_entry_new ();
  gtk_box_pack_start (GTK_BOX (vbox_pas), entry_pas, FALSE, FALSE, 0);
  gtk_entry_set_visibility (GTK_ENTRY (entry_pas), FALSE);
  gtk_entry_set_activates_default (GTK_ENTRY (entry_pas), TRUE);
  hbox_pas = gtk_hbox_new (FALSE, 0);
  gtk_container_add (GTK_CONTAINER (vbox_pas), hbox_pas);
  button_pas = gtk_button_new_from_stock ("gtk-ok");
  gtk_box_pack_start (GTK_BOX (hbox_pas), button_pas, TRUE, TRUE, 0);
  GTK_WIDGET_SET_FLAGS (button_pas, GTK_CAN_DEFAULT);

  button_pas_cancel = gtk_button_new_from_stock ("gtk-cancel");
  gtk_box_pack_start (GTK_BOX (hbox_pas), button_pas_cancel, TRUE, TRUE, 0);
  gtk_window_set_transient_for (GTK_WINDOW (window_pas),
				GTK_WINDOW (pdata->window));
  gtk_window_set_position (GTK_WINDOW (window_pas),
			   GTK_WIN_POS_CENTER_ON_PARENT);

  gtk_window_set_default (GTK_WINDOW (window_pas), button_pas);
  gtk_window_set_focus (GTK_WINDOW (window_pas), entry_pas);
  gtk_window_set_resizable (GTK_WINDOW (window_pas), FALSE);
  g_signal_connect ((gpointer) window_pas, "delete_event",
		    G_CALLBACK (saveset), NULL);
  g_signal_connect_swapped ((gpointer) button_pas_cancel, "clicked",
			    G_CALLBACK (saveset), GTK_OBJECT (NULL));
  g_signal_connect_swapped ((gpointer) button_pas, "clicked",
			    G_CALLBACK (saveset), GTK_OBJECT (entry_pas));

  gtk_widget_show (vbox_pas);
  gtk_widget_show (lab_pas);
  gtk_widget_show (entry_pas);
  gtk_widget_show (button_pas);
  gtk_widget_show (hbox_pas);
  gtk_widget_show (button_pas_cancel);
  gtk_widget_show (window_pas);
  return window_pas;
}

//===========================================================
GtkWidget *
okno_haslo (void)
{
  GtkWidget *window_pas;
  GtkWidget *vbox_pas;
  GtkWidget *lab_pas;
  GtkWidget *entry_pas;
  GtkWidget *button_pas;
  GtkWidget *hbox_pas;
  GtkWidget *button_pas_cancel;



//----------------------------------------------------------
  window_pas = gtk_window_new (GTK_WINDOW_TOPLEVEL);
  gtk_window_set_modal (GTK_WINDOW (window_pas), TRUE);
  gtk_window_set_type_hint (GTK_WINDOW (window_pas),
			    GDK_WINDOW_TYPE_HINT_DIALOG);
  gtk_widget_set_size_request (window_pas, 200, 130);
  gtk_window_set_title (GTK_WINDOW (window_pas), (_("Password")));	//73
  gtk_container_set_border_width (GTK_CONTAINER (window_pas), 10);
  vbox_pas = gtk_vbox_new (FALSE, 0);
  gtk_container_add (GTK_CONTAINER (window_pas), vbox_pas);
  gtk_container_set_border_width (GTK_CONTAINER (vbox_pas), 10);
  if (gtk_toggle_button_get_active (GTK_TOGGLE_BUTTON (pdata->checkbutton4)))
    {
      lab_pas = gtk_label_new (_("Your password"));
    }
  else
    {
      lab_pas = gtk_label_new (_("Root password"));
    }

  gtk_label_set_justify (GTK_LABEL (lab_pas), GTK_JUSTIFY_CENTER);
  gtk_box_pack_start (GTK_BOX (vbox_pas), lab_pas, TRUE, TRUE, 0);
  entry_pas = gtk_entry_new ();
  gtk_box_pack_start (GTK_BOX (vbox_pas), entry_pas, FALSE, FALSE, 0);
  gtk_entry_set_visibility (GTK_ENTRY (entry_pas), FALSE);
  gtk_entry_set_activates_default (GTK_ENTRY (entry_pas), TRUE);
  hbox_pas = gtk_hbox_new (FALSE, 0);
  gtk_container_add (GTK_CONTAINER (vbox_pas), hbox_pas);
  button_pas = gtk_button_new_from_stock ("gtk-ok");
  gtk_box_pack_start (GTK_BOX (hbox_pas), button_pas, TRUE, TRUE, 0);
  GTK_WIDGET_SET_FLAGS (button_pas, GTK_CAN_DEFAULT);

  button_pas_cancel = gtk_button_new_from_stock ("gtk-cancel");
  gtk_box_pack_start (GTK_BOX (hbox_pas), button_pas_cancel, TRUE, TRUE, 0);
  gtk_window_set_transient_for (GTK_WINDOW (window_pas),
				GTK_WINDOW (pdata->window));
  gtk_window_set_position (GTK_WINDOW (window_pas),
			   GTK_WIN_POS_CENTER_ON_PARENT);

  gtk_window_set_default (GTK_WINDOW (window_pas), button_pas);
  gtk_window_set_focus (GTK_WINDOW (window_pas), entry_pas);
  gtk_window_set_resizable (GTK_WINDOW (window_pas), FALSE);
  g_signal_connect ((gpointer) window_pas, "delete_event",
		    G_CALLBACK (passcancel), NULL);
  g_signal_connect_swapped ((gpointer) button_pas_cancel, "clicked",
			    G_CALLBACK (passcancel), GTK_OBJECT (NULL));
  g_signal_connect_swapped ((gpointer) button_pas, "clicked",
			    G_CALLBACK (passcheck), GTK_OBJECT (entry_pas));

  gtk_widget_show (vbox_pas);
  gtk_widget_show (lab_pas);
  gtk_widget_show (entry_pas);
  gtk_widget_show (button_pas);
  gtk_widget_show (hbox_pas);
  gtk_widget_show (button_pas_cancel);
  return window_pas;
}

//====================================================================================
GtkWidget *
okno_postep (void)
{
  GtkWidget *window_con = gtk_window_new (GTK_WINDOW_TOPLEVEL);
  gtk_window_set_modal (GTK_WINDOW (window_con), TRUE);
  gtk_window_set_type_hint (GTK_WINDOW (window_con),
			    GDK_WINDOW_TYPE_HINT_DIALOG);
  gtk_widget_set_size_request (window_con, 350, 110);
  gtk_window_set_title (GTK_WINDOW (window_con), (_("Connecting progress")));	//75
  gtk_container_set_border_width (GTK_CONTAINER (window_con), 10);
  gtk_window_set_transient_for (GTK_WINDOW (window_con),
				GTK_WINDOW (pdata->window));
  gtk_window_set_position (GTK_WINDOW (window_con),
			   GTK_WIN_POS_CENTER_ON_PARENT);
  GtkWidget *vbox_con = gtk_vbox_new (FALSE, 0);
  gtk_container_add (GTK_CONTAINER (window_con), vbox_con);
  gtk_widget_show (vbox_con);
  gtk_container_set_border_width (GTK_CONTAINER (vbox_con), 10);
  GtkWidget *lab_essid = gtk_label_new (gtk_entry_get_text (GTK_ENTRY (pdata->entry_nazwa)));//=============================
  gtk_box_pack_start (GTK_BOX (vbox_con), lab_essid, FALSE, FALSE, 0);
  gtk_widget_show (lab_essid);
  GtkWidget *progresbar_con = gtk_progress_bar_new ();
  gtk_progress_bar_set_text (GTK_PROGRESS_BAR (progresbar_con), " ");
  gtk_progress_bar_set_bar_style (GTK_PROGRESS_BAR (progresbar_con),
				  GTK_PROGRESS_CONTINUOUS);
  gtk_progress_bar_set_fraction (GTK_PROGRESS_BAR (progresbar_con), 0);
  gtk_box_pack_start (GTK_BOX (vbox_con), progresbar_con, FALSE, FALSE, 0);
  gtk_widget_show (progresbar_con);

  GtkWidget *hbox_con = gtk_hbox_new (FALSE, 0);
  gtk_widget_show (hbox_con);
  gtk_box_pack_start (GTK_BOX (vbox_con), hbox_con, FALSE, FALSE, 0);

  GtkWidget *button_cancel = gtk_button_new_from_stock ("gtk-cancel");
  gtk_box_pack_start (GTK_BOX (hbox_con), button_cancel, FALSE, FALSE, 0);
  gtk_widget_show (button_cancel);
  g_signal_connect (G_OBJECT (button_cancel), "clicked",
		    G_CALLBACK (winconcancel), NULL);

  gtk_window_set_resizable (GTK_WINDOW (window_con), FALSE);
  g_signal_connect (G_OBJECT (window_con), "delete_event",
		    G_CALLBACK (winconcancel), NULL);
  pdata->progresbar_con = progresbar_con;
  return window_con;
}

//====================================================================================
GtkWidget *
netkey (void)
{
  GtkWidget *window_netkey;
  GtkWidget *vbox_netkey;
  GtkWidget *lab_netkey;
  GtkWidget *entry_netkey;
  GtkWidget *button_netkey;
  GtkWidget *hbox_netkey;
  GtkWidget *button_netkey_cancel;
  GtkWidget *check;

  window_netkey = gtk_window_new (GTK_WINDOW_TOPLEVEL);
  gtk_window_set_modal (GTK_WINDOW (window_netkey), TRUE);
  gtk_window_set_type_hint (GTK_WINDOW (window_netkey),
			    GDK_WINDOW_TYPE_HINT_DIALOG);
  gtk_widget_set_size_request (window_netkey, 350, 130);
  gtk_window_set_title (GTK_WINDOW (window_netkey), (_("Net key")));	//73
  gtk_container_set_border_width (GTK_CONTAINER (window_netkey), 10);
  vbox_netkey = gtk_vbox_new (FALSE, 0);
  gtk_container_add (GTK_CONTAINER (window_netkey), vbox_netkey);
  gtk_container_set_border_width (GTK_CONTAINER (vbox_netkey), 10);
  lab_netkey = gtk_label_new (_("Key for net"));
  gtk_label_set_justify (GTK_LABEL (lab_netkey), GTK_JUSTIFY_CENTER);
  gtk_box_pack_start (GTK_BOX (vbox_netkey), lab_netkey, TRUE, TRUE, 0);
  entry_netkey = gtk_entry_new ();
  gtk_box_pack_start (GTK_BOX (vbox_netkey), entry_netkey, FALSE, FALSE, 0);
  gtk_entry_set_visibility (GTK_ENTRY (entry_netkey), FALSE);
  gtk_entry_set_activates_default (GTK_ENTRY (entry_netkey), TRUE);
  check = gtk_check_button_new_with_mnemonic (_("Show key"));
  gtk_box_pack_start (GTK_BOX (vbox_netkey), check, FALSE, FALSE, 0);
  gtk_tooltips_set_tip (pdata->tooltips, check,
			_("Show or hide key network"), NULL);
  hbox_netkey = gtk_hbox_new (FALSE, 0);
  gtk_container_add (GTK_CONTAINER (vbox_netkey), hbox_netkey);
  button_netkey = gtk_button_new_from_stock ("gtk-ok");
  gtk_box_pack_start (GTK_BOX (hbox_netkey), button_netkey, TRUE, TRUE, 0);
  GTK_WIDGET_SET_FLAGS (button_netkey, GTK_CAN_DEFAULT);
  button_netkey_cancel = gtk_button_new_from_stock ("gtk-cancel");
  gtk_box_pack_start (GTK_BOX (hbox_netkey), button_netkey_cancel, TRUE, TRUE,0);
  
  gtk_window_set_transient_for (GTK_WINDOW (window_netkey),
				GTK_WINDOW (pdata->window));
  gtk_window_set_position (GTK_WINDOW (window_netkey),
			   GTK_WIN_POS_CENTER_ON_PARENT);
  gtk_window_set_default (GTK_WINDOW (window_netkey), button_netkey);
  gtk_window_set_focus (GTK_WINDOW (window_netkey), entry_netkey);
  gtk_window_set_resizable (GTK_WINDOW (window_netkey), FALSE);
  g_signal_connect ((gpointer) window_netkey, "destroy",
                    G_CALLBACK (gtk_widget_destroy),
                    NULL);
  g_signal_connect_swapped ((gpointer) button_netkey_cancel, "clicked",
                            G_CALLBACK (gtk_widget_destroy),
                            GTK_OBJECT (window_netkey));
  g_signal_connect_swapped ((gpointer) button_netkey, "clicked",
			    G_CALLBACK (netkeyset),
			    GTK_OBJECT (entry_netkey));
  g_signal_connect ((gpointer) check, "toggled",
		    G_CALLBACK (togglednetkey), 
			GTK_OBJECT (entry_netkey));
	
  gtk_widget_show (window_netkey);
  gtk_widget_show (vbox_netkey);
  gtk_widget_show (lab_netkey);
  gtk_widget_show (entry_netkey);
  gtk_widget_show (check);
  gtk_widget_show (button_netkey);
  gtk_widget_show (hbox_netkey);
  gtk_widget_show (button_netkey_cancel);
  return window_netkey;
}

//====================================================================================
GtkWidget *
okno_scan (void)
{
  GtkWidget *window_con = gtk_window_new (GTK_WINDOW_TOPLEVEL);
  gtk_window_set_modal (GTK_WINDOW (window_con), TRUE);
  gtk_window_set_type_hint (GTK_WINDOW (window_con),
			    GDK_WINDOW_TYPE_HINT_DIALOG);
  gtk_widget_set_size_request (window_con, 400, 250);
  gtk_window_set_title (GTK_WINDOW (window_con), _("Scan results"));	//75
  gtk_window_set_transient_for (GTK_WINDOW (window_con),
				GTK_WINDOW (pdata->window));
  gtk_window_set_position (GTK_WINDOW (window_con),
			   GTK_WIN_POS_CENTER_ON_PARENT);
  gtk_widget_show (window_con);

  GtkWidget *vbox_scann = gtk_vbox_new (FALSE, 0);
  gtk_container_add (GTK_CONTAINER (window_con), vbox_scann);
  gtk_widget_show (vbox_scann);

  GtkWidget *scrolledwindow1 = gtk_scrolled_window_new (NULL, NULL);
  gtk_widget_show (scrolledwindow1);
  gtk_container_add (GTK_CONTAINER (vbox_scann), scrolledwindow1);
  gtk_scrolled_window_set_policy (GTK_SCROLLED_WINDOW (scrolledwindow1),
				  GTK_POLICY_NEVER, GTK_POLICY_AUTOMATIC);

  GtkWidget *viewport1 = gtk_viewport_new (NULL, NULL);
  gtk_widget_show (viewport1);
  gtk_container_add (GTK_CONTAINER (scrolledwindow1), viewport1);

  GtkWidget *hbox_scann = gtk_hbox_new (TRUE, 0);
  gtk_box_pack_start (GTK_BOX (vbox_scann), hbox_scann, FALSE, FALSE, 0);
  gtk_widget_show (hbox_scann);

  GtkWidget *button_cancel = gtk_button_new_from_stock ("gtk-cancel");
  gtk_box_pack_start (GTK_BOX (hbox_scann), button_cancel, FALSE, FALSE, 0);
  gtk_widget_show (button_cancel);
  g_signal_connect_swapped ((gpointer) button_cancel, "clicked",
			    G_CALLBACK (scannend), GTK_OBJECT (window_con));

  pdata->checkbutton2 =
    gtk_check_button_new_with_mnemonic (_("Auto rescann"));
  gtk_box_pack_start (GTK_BOX (hbox_scann), pdata->checkbutton2, TRUE, TRUE,
		      0);
  gtk_widget_show (pdata->checkbutton2);
  gtk_tooltips_set_tip (pdata->tooltips, pdata->checkbutton2,
			_("Mark for autorescann."), NULL);
  g_signal_connect ((gpointer) pdata->checkbutton2, "toggled",
		    G_CALLBACK (toggled2), NULL);

  pdata->button_rescann = gtk_button_new_with_mnemonic (_("Rescann"));
  gtk_box_pack_start (GTK_BOX (hbox_scann), pdata->button_rescann, FALSE,
		      FALSE, 0);
  gtk_widget_show (pdata->button_rescann);
  g_signal_connect_swapped ((gpointer) pdata->button_rescann, "clicked",
			    G_CALLBACK (rescann), GTK_OBJECT (viewport1));

  g_signal_connect_swapped ((gpointer) window_con, "delete_event",
			    G_CALLBACK (scannend), GTK_OBJECT (window_con));
  pdata->scann1 = scan (viewport1);
  pdata->scantest = 1;

  return window_con;
}

int
create_filechooserdialog1 (GtkWidget * entry)
{
  GtkWidget *dialog;

  dialog = gtk_file_chooser_dialog_new (_("Browsing"), GTK_WINDOW (pdata->window), GTK_FILE_CHOOSER_ACTION_OPEN, GTK_STOCK_CANCEL, GTK_RESPONSE_CANCEL, GTK_STOCK_OPEN, GTK_RESPONSE_ACCEPT, NULL);	//85
//  gtk_file_chooser_set_current_folder (GTK_FILE_CHOOSER(dialog),  gtk_entry_get_text (GTK_ENTRY (entry)));

  gtk_file_chooser_set_filename (GTK_FILE_CHOOSER (dialog),
				 gtk_entry_get_text (GTK_ENTRY (entry)));

  if (gtk_dialog_run (GTK_DIALOG (dialog)) == GTK_RESPONSE_ACCEPT)
    {

      char *filename;

      filename = gtk_file_chooser_get_filename (GTK_FILE_CHOOSER (dialog));
      gtk_entry_set_text (GTK_ENTRY (entry), filename);
    }

  gtk_widget_destroy (dialog);
  return (1);
}
