#include <dirent.h>
#include <stdio.h>
#include <string.h>
#include <stdlib.h>
#include <signal.h>
#include <sys/types.h>
#include <sys/wait.h>
#include <unistd.h>
#include <gtk/gtk.h>
#include <sys/stat.h>
#include <fcntl.h>
#include "gwifimeter.h"
#include "profil.h"
#include "callback.h"
#include "but_connect.h"
#include "interface.h"

#define ICONS_DIR PACKAGE_DATA_DIR G_DIR_SEPARATOR_S "themes/icons/"
#define RC_DIR PACKAGE_DATA_DIR G_DIR_SEPARATOR_S "themes/rc/"


//==============================================================================
void
clear_combo_list (GtkComboBox * combo_box)
{
  GtkListStore *store;
  GtkTreeModel *model;
  model = gtk_combo_box_get_model (GTK_COMBO_BOX (combo_box));
  store = GTK_LIST_STORE (model);
  gtk_list_store_clear (store);
  freeprofil ();
}

//==============================================================================
void
clear_combo_entry (GtkComboBox * combo_box)
{
  gtk_entry_set_text (GTK_ENTRY (GTK_BIN ((combo_box))->child), (""));
}

//==============================================================================
void
set_combo_entry_taxt (GtkComboBox * combo_box, char *text)
{
  gtk_entry_set_text (GTK_ENTRY (GTK_BIN ((combo_box))->child), (text));
}

//==============================================================================


//==============================================================================
void
comboboxentry1_changed (void)
{
  int len = gtk_combo_box_get_active (GTK_COMBO_BOX (pdata->comboboxentry1));
  if (len == -1)
    return;
  int prolen = pdata->tab_profil[0]->len;
  --prolen;
  char *tagret;
  if (prolen >= len)
    {
      tagret = strstr (pdata->tab_profil[len]->macaddres, "mac set ");	//szukam mac
      if (tagret != NULL)
	{
	  gtk_combo_box_set_active (GTK_COMBO_BOX (pdata->combobox_mac), 1);
	  gtk_entry_set_text (GTK_ENTRY (pdata->entry_mac), tagret + 8);
	}
      else
	gtk_combo_box_set_active (GTK_COMBO_BOX (pdata->combobox_mac), 0);

      gtk_entry_set_text (GTK_ENTRY (pdata->entry_nazwa),
			  pdata->tab_profil[len]->essid);

      tagret = strstr (pdata->tab_profil[len]->key, "key open ");	//szukam key
      if (tagret != NULL)
	{
	  gtk_combo_box_set_active (GTK_COMBO_BOX (pdata->combobox_keymode),
				    1);
	  gtk_entry_set_text (GTK_ENTRY (pdata->entry_key), tagret + 9);
	}
      tagret = strstr (pdata->tab_profil[len]->key, "key shared ");	//szukam key
      if (tagret != NULL)
	{
	  gtk_combo_box_set_active (GTK_COMBO_BOX (pdata->combobox_keymode),
				    2);
	  gtk_entry_set_text (GTK_ENTRY (pdata->entry_key), tagret + 11);
	}
      tagret = strstr (pdata->tab_profil[len]->key, "key WPA-PSK/TKIP ");	//szukam key
      if (tagret != NULL)
	{
	  gtk_combo_box_set_active (GTK_COMBO_BOX (pdata->combobox_keymode),
				    3);
	  gtk_entry_set_text (GTK_ENTRY (pdata->entry_key), tagret + 17);
	}
      tagret = strstr (pdata->tab_profil[len]->key, "key WPA-PSK/AES ");	//szukam key
      if (tagret != NULL)
	{
	  gtk_combo_box_set_active (GTK_COMBO_BOX (pdata->combobox_keymode),
				    4);
	  gtk_entry_set_text (GTK_ENTRY (pdata->entry_key), tagret + 16);
	}
      tagret = strstr (pdata->tab_profil[len]->key, "key off");	//szukam key
      if (tagret != NULL)
	{
	  gtk_combo_box_set_active (GTK_COMBO_BOX (pdata->combobox_keymode),
				    0);
	  gtk_entry_set_text (GTK_ENTRY (pdata->entry_key), "");
	}
      tagret = strstr (pdata->tab_profil[len]->ipaddres, "ip no");	//szukam ip
      if (tagret != NULL)
	{
	  gtk_combo_box_set_active (GTK_COMBO_BOX (pdata->combobox_ip), 0);
	  gtk_entry_set_text (GTK_ENTRY (pdata->entry_ip), "");
	}
      tagret = strstr (pdata->tab_profil[len]->ipaddres, "ip auto");	//szukam ip
      if (tagret != NULL)
	{
	  gtk_combo_box_set_active (GTK_COMBO_BOX (pdata->combobox_ip), 1);
	  gtk_entry_set_text (GTK_ENTRY (pdata->entry_ip), "");
	}
      tagret = strstr (pdata->tab_profil[len]->ipaddres, "ip static ");	//szukam ip
      if (tagret != NULL)
	{
	  gtk_combo_box_set_active (GTK_COMBO_BOX (pdata->combobox_ip), 2);
	  gtk_entry_set_text (GTK_ENTRY (pdata->entry_ip), tagret + 10);
	}
      tagret = strstr (pdata->tab_profil[len]->gateway, "gw no");	//szukam gw
      if (tagret != NULL)
	{
	  gtk_combo_box_set_active (GTK_COMBO_BOX (pdata->combobox_gw), 0);
	  gtk_entry_set_text (GTK_ENTRY (pdata->entry_gw), "");
	}
      tagret = strstr (pdata->tab_profil[len]->gateway, "gw auto");	//szukam gw
      if (tagret != NULL)
	{
	  gtk_combo_box_set_active (GTK_COMBO_BOX (pdata->combobox_gw), 1);
	  gtk_entry_set_text (GTK_ENTRY (pdata->entry_gw), "");
	}
      tagret = strstr (pdata->tab_profil[len]->gateway, "gw static ");	//szukam gw
      if (tagret != NULL)
	{
	  gtk_combo_box_set_active (GTK_COMBO_BOX (pdata->combobox_gw), 2);
	  gtk_entry_set_text (GTK_ENTRY (pdata->entry_gw), tagret + 10);
	}
      ////////////////////////
      gtk_combo_box_set_active (GTK_COMBO_BOX (pdata->comboboxentry_mode),
				pdata->tab_profil[len]->mode);
      //printf("\nmode - %d\n",pdata->tab_profil[len]->mode);//
      //printf("\nmodeactive - %d\n",gtk_combo_box_get_active(GTK_COMBO_BOX (pdata->comboboxentry_mode)));
      gtk_combo_box_set_active (GTK_COMBO_BOX (pdata->comboboxentry_channel),
				pdata->tab_profil[len]->channel);
      //printf("channel- %d\n",pdata->tab_profil[len]->channel);
      gtk_combo_box_set_active (GTK_COMBO_BOX (pdata->comboboxentry_rate),
				pdata->tab_profil[len]->rate);
      //printf("rate- %d\n",pdata->tab_profil[len]->rate);
      if (pdata->tab_profil[len]->startactive == 1)
	{
	  gtk_toggle_button_set_active (GTK_TOGGLE_BUTTON
					(pdata->checkbutton5), TRUE);
	}
      else
	gtk_toggle_button_set_active (GTK_TOGGLE_BUTTON (pdata->checkbutton5),
				      FALSE);
      if (pdata->tab_profil[len]->hiden == 1)
	{
	  gtk_toggle_button_set_active (GTK_TOGGLE_BUTTON
					(pdata->checkbutton6), TRUE);
	}
      else
	gtk_toggle_button_set_active (GTK_TOGGLE_BUTTON (pdata->checkbutton6),
				      FALSE);
      if (pdata->tab_profil[len]->available == 1)
	{
	  gtk_toggle_button_set_active (GTK_TOGGLE_BUTTON
					(pdata->checkbutton7), TRUE);
	}
      else
	gtk_toggle_button_set_active (GTK_TOGGLE_BUTTON (pdata->checkbutton7),
				      FALSE);
    }
}

//==================================================================================
void
delprofil (void)
{
  if (strlen
      (gtk_combo_box_get_active_text (GTK_COMBO_BOX (pdata->comboboxentry1)))
      > 0)
    {
      char *tab2, *tab4, *profil, *profil1;
      int co1, file;
      file = open (pdata->user, O_RDONLY | O_CREAT, S_IRUSR | S_IWUSR);
      if (file > 0)
	{
	  tab4 = (char *) g_malloc (1);

	  if (pdata->user == 0)
	    printf ("virtual memory exceeded\n");

	  tab2 = (char *) g_malloc (1);

	  if (tab2 == 0)
	    printf ("virtual memory exceeded\n");

	  *tab2 = '\0';
	  bzero (tab4, sizeof (tab4));

	  while (1)
	    {
	      co1 = read (file, tab2 =
			  (char *) g_realloc (tab2, sizeof (tab2) + 1),
			  sizeof (tab2));
	      if (co1 == 0)
		{
		  close (file);
		  break;
		}

	      tab4 = g_realloc (tab4, strlen (tab4) + sizeof (tab2) + 1);
	      strncat (tab4, tab2, sizeof (tab2));
	      bzero (tab2, sizeof (tab2));
	    }
	  g_free (tab2);
	
      char *profil3;
      profil3 =
	(char *)
	g_malloc (strlen
		  (gtk_combo_box_get_active_text
		   (GTK_COMBO_BOX (pdata->comboboxentry1))) + 9);
      strcpy (profil3, "PROFIL ");
      strcat (profil3,
	      gtk_combo_box_get_active_text (GTK_COMBO_BOX
					     (pdata->comboboxentry1)));
      strcat (profil3, "\n");
      profil1 = strstr (tab4, profil3);
      g_free (profil3);
      if (profil1 != NULL)
	{
	  profil = strstr (profil1 + 6, "PROFIL");	//szukam kolejnego profilu by oznaczyc koniec
	  if (profil != NULL)
	    {
	      strcpy (profil1, profil);
	    }
	  else
	    {
	      *(profil1) = '\0';
	    }
	}

      file =
	open (pdata->user, O_WRONLY | O_CREAT | O_TRUNC, S_IRUSR | S_IWUSR);
      if (file > 0)
	{
	  write (file, tab4, strlen (tab4));
	  close (file);
	  clear_combo_list (GTK_COMBO_BOX (pdata->comboboxentry1));
	  clear_combo_entry (GTK_COMBO_BOX (pdata->comboboxentry1));
	  appendprofil ();
	}
      g_free (tab4);
      }
    }
}

//========================================================================================
void
addprofil (void)
{
  if (strlen
      (gtk_combo_box_get_active_text (GTK_COMBO_BOX (pdata->comboboxentry1)))
      > 0)
    {
      char *tab2, *tab4, *profil1, *profil;
      int co1, file;
      file = open (pdata->user, O_RDONLY | O_CREAT, S_IRUSR | S_IWUSR);
      if (file > 0)
	{
	  tab4 = (char *) g_malloc (1);
	  if (pdata->user == 0)
	    printf ("virtual memory exceeded\n");

	  tab2 = (char *) g_malloc (1);
	  if (tab2 == 0)
	    printf ("virtual memory exceeded\n");

	  *tab2 = '\0';
	  bzero (tab4, sizeof (tab4));
	  while (1)
	    {
	      co1 = read (file, tab2 =
			  (char *) g_realloc (tab2, sizeof (tab2) + 1),
			  sizeof (tab2));
	      if (co1 == 0)
		{
		  close (file);
		  break;
		}

	      tab4 = g_realloc (tab4, strlen (tab4) + sizeof (tab2) + 1);
	      strncat (tab4, tab2, sizeof (tab2));
	      bzero (tab2, sizeof (tab2));
	    }
	  g_free (tab2);
	  char *profil3;
	  profil3 =
	    (char *)
	    g_malloc (strlen
		      (gtk_combo_box_get_active_text
		       (GTK_COMBO_BOX (pdata->comboboxentry1))) + 9);
	  strcpy (profil3, "PROFIL ");
	  strcat (profil3,
		  gtk_combo_box_get_active_text (GTK_COMBO_BOX
						 (pdata->comboboxentry1)));
	  strcat (profil3, "\n");
	  profil1 = strstr (tab4, profil3);
	  g_free (profil3);
	  if (profil1 != NULL)
	    {
	      profil = strstr (profil1 + 6, "PROFIL");
	      if (profil != NULL)
		{
		  strcpy (profil1, profil);
		}
	      else
		{
		  *(profil1) = '\0';
		}
	    }

	  tab4 =
	    g_realloc (tab4,
		       strlen (tab4) + 165 +
		       strlen (gtk_combo_box_get_active_text
			       (GTK_COMBO_BOX (pdata->comboboxentry1))) +
		       strlen (gtk_entry_get_text
			       (GTK_ENTRY (pdata->entry_nazwa))));
	  strcat (tab4, "PROFIL ");
	  strcat (tab4,
		  gtk_combo_box_get_active_text (GTK_COMBO_BOX
						 (pdata->comboboxentry1)));
	  strcat (tab4, "\n");
	  strcat (tab4, "essid ");
	  strcat (tab4, gtk_entry_get_text (GTK_ENTRY (pdata->entry_nazwa)));
	  strcat (tab4, "\n");
	  switch (gtk_combo_box_get_active
		  (GTK_COMBO_BOX (pdata->combobox_keymode)))
	    {
	    case 0:
	      strcat (tab4, "key off\n");
	      break;
	    case 1:
	      strcat (tab4, "key open ");
	      strcat (tab4,
		      gtk_entry_get_text (GTK_ENTRY (pdata->entry_key)));
	      strcat (tab4, "\n");
	      break;
	    case 2:
	      strcat (tab4, "key restricted ");
	      strcat (tab4,
		      gtk_entry_get_text (GTK_ENTRY (pdata->entry_key)));
	      strcat (tab4, "\n");
	      break;
	    case 3:
	      strcat (tab4, "key WPA-PSK/TKIP ");
	      strcat (tab4,
		      gtk_entry_get_text (GTK_ENTRY (pdata->entry_key)));
	      strcat (tab4, "\n");
	      break;
	    case 4:
	      strcat (tab4, "key WPA-PSK/AES ");
	      strcat (tab4,
		      gtk_entry_get_text (GTK_ENTRY (pdata->entry_key)));
	      strcat (tab4, "\n");
	      break;
	    }


	  switch (gtk_combo_box_get_active
		  (GTK_COMBO_BOX (pdata->comboboxentry_channel)))
	    {
	    case 0:
	      strcat (tab4, "channel auto\n");
	      break;
	    case 1:
	      strcat (tab4, "channel 1\n");
	      break;
	    case 2:
	      strcat (tab4, "channel 2\n");
	      break;
	    case 3:
	      strcat (tab4, "channel 3\n");
	      break;
	    case 4:
	      strcat (tab4, "channel 4\n");
	      break;
	    case 5:
	      strcat (tab4, "channel 5\n");
	      break;
	    case 6:
	      strcat (tab4, "channel 6\n");
	      break;
	    case 7:
	      strcat (tab4, "channel 7\n");
	      break;
	    case 8:
	      strcat (tab4, "channel 8\n");
	      break;
	    case 9:
	      strcat (tab4, "channel 9\n");
	      break;
	    case 10:
	      strcat (tab4, "channel 10\n");
	      break;
	    case 11:
	      strcat (tab4, "channel 11\n");
	      break;
	    case 12:
	      strcat (tab4, "channel 12\n");
	      break;
	    case 13:
	      strcat (tab4, "channel 13\n");
	      break;
	    case 14:
	      strcat (tab4, "channel 14\n");
	      break;
	    }

	  switch (gtk_combo_box_get_active
		  (GTK_COMBO_BOX (pdata->comboboxentry_rate)))
	    {
	    case 0:
	      strcat (tab4, "rate auto\n");
	      break;
	    case 1:
	      strcat (tab4, "rate 1M\n");
	      break;
	    case 2:
	      strcat (tab4, "rate 2M\n");
	      break;
	    case 3:
	      strcat (tab4, "rate 5.5M\n");
	      break;
	    case 4:
	      strcat (tab4, "rate 11M\n");
	      break;
	    case 5:
	      strcat (tab4, "rate 9M\n");
	      break;
	    case 6:
	      strcat (tab4, "rate 18M\n");
	      break;
	    case 7:
	      strcat (tab4, "rate 24M\n");
	      break;
	    case 8:
	      strcat (tab4, "rate 36M\n");
	      break;
	    case 9:
	      strcat (tab4, "rate 54M\n");
	      break;
	    case 10:
	      strcat (tab4, "rate 108M\n");
	      break;
	    }

	  switch (gtk_combo_box_get_active
		  (GTK_COMBO_BOX (pdata->comboboxentry_mode)))
	    {
	    case 0:
	      strcat (tab4, "mode managed\n");
	      break;
	    case 1:
	      strcat (tab4, "mode ad-hoc\n");
	      break;
	    case 2:
	      strcat (tab4, "mode master\n");
	      break;
	    case 3:
	      strcat (tab4, "mode monitor\n");
	      break;
	    }

	  if (gtk_combo_box_get_active (GTK_COMBO_BOX (pdata->combobox_mac))
	      == 0)
	    {
	      strcat (tab4, "mac no\n");
	    }
	  if (gtk_combo_box_get_active (GTK_COMBO_BOX (pdata->combobox_mac))
	      == 1)
	    {
	      strcat (tab4, "mac set ");
	      strcat (tab4,
		      gtk_entry_get_text (GTK_ENTRY (pdata->entry_mac)));
	      strcat (tab4, "\n");
	    }
	  if (gtk_combo_box_get_active (GTK_COMBO_BOX (pdata->combobox_ip)) ==
	      0)
	    {
	      strcat (tab4, "ip no\n");
	    }
	  if (gtk_combo_box_get_active (GTK_COMBO_BOX (pdata->combobox_ip)) ==
	      1)
	    {
	      strcat (tab4, "ip auto\n");
	    }
	  if (gtk_combo_box_get_active (GTK_COMBO_BOX (pdata->combobox_ip)) ==
	      2)
	    {
	      strcat (tab4, "ip static ");
	      strcat (tab4, gtk_entry_get_text (GTK_ENTRY (pdata->entry_ip)));
	      strcat (tab4, "\n");
	    }
	  if (gtk_combo_box_get_active (GTK_COMBO_BOX (pdata->combobox_gw)) ==
	      0)
	    {
	      strcat (tab4, "gw no\n");
	    }
	  if (gtk_combo_box_get_active (GTK_COMBO_BOX (pdata->combobox_gw)) ==
	      1)
	    {
	      strcat (tab4, "gw auto\n");
	    }
	  if (gtk_combo_box_get_active (GTK_COMBO_BOX (pdata->combobox_gw)) ==
	      2)
	    {
	      strcat (tab4, "gw static ");
	      strcat (tab4, gtk_entry_get_text (GTK_ENTRY (pdata->entry_gw)));
	      strcat (tab4, "\n");
	    }
	  profil1 = strstr (tab4, "active_on_start");
	  if (gtk_toggle_button_get_active
	      (GTK_TOGGLE_BUTTON (pdata->checkbutton5)) && profil1 == NULL)
	    {
	      strcat (tab4, "active_on_start\n");
	    }
	  if (gtk_toggle_button_get_active
	      (GTK_TOGGLE_BUTTON (pdata->checkbutton5)) && profil1 != NULL)
	    {
	      GtkWidget *dialog =
		gtk_message_dialog_new (GTK_WINDOW (pdata->window),
					GTK_DIALOG_DESTROY_WITH_PARENT,
					GTK_MESSAGE_ERROR,
					GTK_BUTTONS_CLOSE,
					"activate on startup option is active in other profile");
	      gtk_dialog_run (GTK_DIALOG (dialog));
	      gtk_widget_destroy (dialog);
	      g_free (tab4);
	      return;
	    }
	  if (gtk_toggle_button_get_active
	      (GTK_TOGGLE_BUTTON (pdata->checkbutton6)))
	    {
	      strcat (tab4, "hiden_network\n");
	    }
	  if (gtk_toggle_button_get_active
	      (GTK_TOGGLE_BUTTON (pdata->checkbutton7)))
	    {
	      strcat (tab4, "active_visible\n");
	    }
	  file =
	    open (pdata->user, O_WRONLY | O_CREAT | O_TRUNC,
		  S_IRUSR | S_IWUSR);
	  if (file > 0)
	    {
	      write (file, tab4, strlen (tab4));
	      close (file);
	      clear_combo_list (GTK_COMBO_BOX (pdata->comboboxentry1));
	      appendprofil ();
	    }


	  g_free (tab4);
	}
    }
}

//============================================================
//============================================================
void
appendprofil (void)
{
  int file, co1;
  char *tab2, *tab4, *profil, *profil1, *target;
  gint len = 0;
  file = open (pdata->user, O_RDONLY | O_CREAT, S_IRUSR | S_IWUSR);
  if (file > 0)
    {
      tab4 = (char *) g_malloc (1);
      if (pdata->user == 0)
	printf ("virtual memory exceeded\n");
      tab2 = (char *) g_malloc (1);
      if (tab2 == 0)
	printf ("virtual memory exceeded\n");
      *tab2 = '\0';
      bzero (tab4, sizeof (tab4));
      while (1)
	{
	  co1 = read (file, tab2 =
		      (char *) g_realloc (tab2, sizeof (tab2) + 1),
		      sizeof (tab2));
	  if (co1 == 0)
	    {
	      close (file);
	      break;
	    }

	  tab4 = g_realloc (tab4, strlen (tab4) + sizeof (tab2) + 1);
	  strncat (tab4, tab2, sizeof (tab2));
	  bzero (tab2, sizeof (tab2));
	}
      g_free (tab2);
      pdata->tab_profil =
	(struct profil **) g_malloc (sizeof (struct profil *));
      profil1 = strstr (tab4, "PROFIL ");
      while (1)
	{
	  if (profil1 != NULL)
	    {
	      pdata->tab_profil =
		(struct profil **) g_realloc (pdata->tab_profil,
					      (len +
					       1) * sizeof (struct profil *));
	      pdata->tab_profil[len] =
		(struct profil *) malloc (sizeof (struct profil));
	      profil1 = profil1 + 7;
	      profil = profil1;
	      profil1 = strstr (profil1, "PROFIL ");
	      strncpy (pdata->tab_profil[len]->profil =
		       (gchar *) g_malloc (endline (profil) + 2), profil,
		       endline (profil));
	      pdata->tab_profil[len]->profil[endline (profil)] = '\0';

	      target = search ("essid ", profil, profil1);
	      if (target != NULL)
		{
		  strncpy (pdata->tab_profil[len]->essid = (gchar *) g_malloc (endline (target + 6) + 2), target + 6, endline (target + 6));	//essid
		  pdata->tab_profil[len]->essid[endline (target + 6)] = '\0';
		  //printf("essid %d\n",endline (target+6));
		}
	      else
		pdata->tab_profil[len]->essid = (gchar *) g_malloc (1);

	      target = search ("key ", profil, profil1);
	      if (target != NULL)
		{
		  strncpy (pdata->tab_profil[len]->key = (gchar *) g_malloc (endline (target) + 1), target, endline (target));	//key
		  pdata->tab_profil[len]->key[endline (target)] = '\0';
		}
	      else
		pdata->tab_profil[len]->key = (gchar *) g_malloc (1);
	      target = search ("mac ", profil, profil1);
	      if (target != NULL)
		{
		  strncpy (pdata->tab_profil[len]->macaddres = (gchar *) g_malloc (endline (target) + 1), target, endline (target));	//mac
		  pdata->tab_profil[len]->macaddres[endline (target)] = '\0';
		}
	      else
		pdata->tab_profil[len]->macaddres = (gchar *) g_malloc (1);
	      target = search ("ip ", profil, profil1);
	      if (target != NULL)
		{
		  strncpy (pdata->tab_profil[len]->ipaddres = (gchar *) g_malloc (endline (target) + 1), target, endline (target));	//ip
		  pdata->tab_profil[len]->ipaddres[endline (target)] = '\0';
		}
	      else
		pdata->tab_profil[len]->ipaddres = (gchar *) g_malloc (1);
	      target = search ("gw ", profil, profil1);
	      if (target != NULL)
		{
		  strncpy (pdata->tab_profil[len]->gateway =
			   (gchar *) g_malloc (endline (target) + 1), target,
			   endline (target));
		  pdata->tab_profil[len]->gateway[endline (target)] = '\0';
		}
	      else
		pdata->tab_profil[len]->gateway = (gchar *) g_malloc (1);
	      pdata->tab_profil[len]->channel = 0;
	      if (search ("channel auto\n", profil, profil1) != NULL)
		pdata->tab_profil[len]->channel = 0;
	      if (search ("channel 1\n", profil, profil1) != NULL)
		pdata->tab_profil[len]->channel = 1;
	      if (search ("channel 2\n", profil, profil1) != NULL)
		pdata->tab_profil[len]->channel = 2;
	      if (search ("channel 3\n", profil, profil1) != NULL)
		pdata->tab_profil[len]->channel = 3;
	      if (search ("channel 4\n", profil, profil1) != NULL)
		pdata->tab_profil[len]->channel = 4;
	      if (search ("channel 5\n", profil, profil1) != NULL)
		pdata->tab_profil[len]->channel = 5;
	      if (search ("channel 6\n", profil, profil1) != NULL)
		pdata->tab_profil[len]->channel = 6;
	      if (search ("channel 7\n", profil, profil1) != NULL)
		pdata->tab_profil[len]->channel = 7;
	      if (search ("channel 8\n", profil, profil1) != NULL)
		pdata->tab_profil[len]->channel = 8;
	      if (search ("channel 9\n", profil, profil1) != NULL)
		pdata->tab_profil[len]->channel = 9;
	      if (search ("channel 10\n", profil, profil1) != NULL)
		pdata->tab_profil[len]->channel = 10;
	      if (search ("channel 11\n", profil, profil1) != NULL)
		pdata->tab_profil[len]->channel = 11;
	      if (search ("channel 12\n", profil, profil1) != NULL)
		pdata->tab_profil[len]->channel = 12;
	      if (search ("channel 13\n", profil, profil1) != NULL)
		pdata->tab_profil[len]->channel = 13;
	      if (search ("channel 14\n", profil, profil1) != NULL)
		pdata->tab_profil[len]->channel = 14;
	      pdata->tab_profil[len]->rate = 0;
	      if (search ("rate auto\n", profil, profil1) != NULL)
		pdata->tab_profil[len]->rate = 0;
	      if (search ("rate 1M", profil, profil1) != NULL)
		pdata->tab_profil[len]->rate = 1;
	      if (search ("rate 2M", profil, profil1) != NULL)
		pdata->tab_profil[len]->rate = 2;
	      if (search ("rate 5.5M", profil, profil1) != NULL)
		pdata->tab_profil[len]->rate = 3;
	      if (search ("rate 9M", profil, profil1) != NULL)
		pdata->tab_profil[len]->rate = 4;
	      if (search ("rate 11M", profil, profil1) != NULL)
		pdata->tab_profil[len]->rate = 5;
	      if (search ("rate 18M", profil, profil1) != NULL)
		pdata->tab_profil[len]->rate = 6;
	      if (search ("rate 24M", profil, profil1) != NULL)
		pdata->tab_profil[len]->rate = 7;
	      if (search ("rate 36M", profil, profil1) != NULL)
		pdata->tab_profil[len]->rate = 8;
	      if (search ("rate 54M", profil, profil1) != NULL)
		pdata->tab_profil[len]->rate = 9;
	      if (search ("rate 108M", profil, profil1) != NULL)
		pdata->tab_profil[len]->rate = 10;
	      pdata->tab_profil[len]->mode = 0;
	      if (search ("mode managed", profil, profil1) != NULL)
		pdata->tab_profil[len]->mode = 0;
	      if (search ("mode ad-hoc", profil, profil1) != NULL)
		pdata->tab_profil[len]->mode = 1;
	      if (search ("mode master", profil, profil1) != NULL)
		pdata->tab_profil[len]->mode = 2;
	      if (search ("mode monitor", profil, profil1) != NULL)
		pdata->tab_profil[len]->mode = 3;
	      if (search ("hiden_network", profil, profil1) != NULL)
		pdata->tab_profil[len]->hiden = 1;
	      else
		pdata->tab_profil[len]->hiden = 0;
	      if (search ("active_on_start", profil, profil1) != NULL)
		pdata->tab_profil[len]->startactive = 1;
	      else
		pdata->tab_profil[len]->startactive = 0;
	      if (search ("active_visible", profil, profil1) != NULL)
		pdata->tab_profil[len]->available = 1;
	      else
		pdata->tab_profil[len]->available = 0;
	      pdata->tab_profil[len]->position = co1;

	      gtk_combo_box_append_text (GTK_COMBO_BOX
					 (pdata->comboboxentry1),
					 pdata->tab_profil[len]->profil);
	      ++len;
	    }
	  else
	    {

	      //pdata->prolen=len;
	      if (len == 0)
		pdata->tab_profil[0] =
		  (struct profil *) malloc (sizeof (struct profil));
	      pdata->tab_profil[0]->len = len;
	      break;
	    }
	}
      g_free (tab4);
    }
}

//==============================================================================
void
freeprofil (void)
{
  int len = pdata->tab_profil[0]->len;
  if (len == 0)
    {
      free (pdata->tab_profil[0]);
      free (pdata->tab_profil);
    }
  else
    while (len)
      {
	--len;
	free (pdata->tab_profil[len]->profil);
	free (pdata->tab_profil[len]->essid);
	free (pdata->tab_profil[len]->key);
	free (pdata->tab_profil[len]->macaddres);
	free (pdata->tab_profil[len]->ipaddres);
	free (pdata->tab_profil[len]->gateway);
	if (len == 0)
	  {
	    free (pdata->tab_profil[len]);
	    free (pdata->tab_profil);
	  }
      }
  //printf("free profil\n");
}

//==============================================================================
void
prefileread (void)
{
  strcpy (pdata->interface, "");
  strcpy (pdata->themes, "");
  strcpy (pdata->diricon, "default");
  pdata->checkrc = 0;
  char string[100];
  FILE *fd;
  fd = fopen (pdata->user, "r");

  if (fd == NULL)
    {
      printf ("\n error opening file \n");
      return;
    }
  while (1)
    {
      if (fgets (&string[0], 99, fd) > 0)
	{
	  if (string[0] != '#')
	    {
	      if (strstr (string, "ifacewifi ") != NULL)
		{
		  string[strlen (string) - 1] = '\0';
		  strcpy (pdata->interface, &string[10]);
		}
	      if (strstr (string, "themes ") != NULL)
		{
		  string[strlen (string) - 1] = '\0';
		  strcpy (pdata->themes, &string[7]);
		}
	      if (strstr (string, "diricon ") != NULL)
		{
		  string[strlen (string) - 1] = '\0';
		  strcpy (pdata->diricon, &string[8]);
		}
	    }
	}
      else
	break;
    }
  fclose (fd);
}

//====================================================================
void
fileread (void)
{
  defaultset ();
  if (strlen (pdata->diricon) > 0)
    {
      if (0 >=
	  langappend (ICONS_DIR, pdata->diricon,
		      GTK_COMBO_BOX (pdata->comboboxentry_icon)))
	if (0 >=
	    langappend ("themes/icons", pdata->diricon,
			GTK_COMBO_BOX (pdata->comboboxentry_icon)))
	  if (0 >=
	      langappend (ICONS_DIR, "default\n",
			  GTK_COMBO_BOX (pdata->comboboxentry_icon)))
	    langappend ("themes/icons", "default\n",
			GTK_COMBO_BOX (pdata->comboboxentry_icon));
    }
  else
    {
      if (0 >=
	  langappend (ICONS_DIR, "default",
		      GTK_COMBO_BOX (pdata->comboboxentry_icon)))
	langappend ("themes/icons", "default\n",
		    GTK_COMBO_BOX (pdata->comboboxentry_icon));
    }

  if (strlen (pdata->themes) > 0)
    {
      if (0 >=
	  langappend (RC_DIR, pdata->themes,
		      GTK_COMBO_BOX (pdata->comboboxentry_theme)))
	if (0 >=
	    langappend ("themes/rc/", pdata->themes,
			GTK_COMBO_BOX (pdata->comboboxentry_theme)))
	  if (0 >=
	      langappend (RC_DIR, "default\n",
			  GTK_COMBO_BOX (pdata->comboboxentry_theme)))
	    langappend ("themes/rc/", "default\n",
			GTK_COMBO_BOX (pdata->comboboxentry_theme));
    }
  else
    {
      if (0 >=
	  langappend (RC_DIR, "default",
		      GTK_COMBO_BOX (pdata->comboboxentry_theme)))
	langappend ("themes/rc/", "default\n",
		    GTK_COMBO_BOX (pdata->comboboxentry_theme));
    }

  char string[100];
  FILE *fd;
  fd = fopen (pdata->user, "r");

  if (fd == NULL)
    {
      printf ("\n error opening file \n");
      return;
    }
//gtk_toggle_button_set_active (GTK_TOGGLE_BUTTON (pdata->checkbutton11),FALSE);
  while (1)
    {
      if (fgets (&string[0], 99, fd) > 0)
	{
	  if (string[0] != '#')
	    {
	      if (pdata->window)
		{
		  if (strstr (string, "iwconfig ") != NULL)
		    {
		      string[strlen (string) - 1] = '\0';
		      gtk_entry_set_text (GTK_ENTRY
					  (pdata->entry_set_iwconfig),
					  &string[9]);
		    }
		  if (strstr (string, "iwlist ") != NULL)
		    {
		      string[strlen (string) - 1] = '\0';
		      gtk_entry_set_text (GTK_ENTRY (pdata->entry_set_iwlist),
					  &string[7]);
		    }
		  if (strstr (string, "iwpriv ") != NULL)
		    {
		      string[strlen (string) - 1] = '\0';
		      gtk_entry_set_text (GTK_ENTRY (pdata->entry_set_iwpriv),
					  &string[7]);
		    }
		  if (strstr (string, "dhcpclient ") != NULL)
		    {
		      string[strlen (string) - 1] = '\0';
		      gtk_entry_set_text (GTK_ENTRY (pdata->entry_set_dhcp),
					  &string[11]);
		    }
		  if (strstr (string, "ifconfig ") != NULL)
		    {
		      string[strlen (string) - 1] = '\0';
		      gtk_entry_set_text (GTK_ENTRY
					  (pdata->entry_set_ifconfig),
					  &string[9]);
		    }
		  if (strstr (string, "route ") != NULL)
		    {
		      string[strlen (string) - 1] = '\0';
		      gtk_entry_set_text (GTK_ENTRY (pdata->entry_set_route),
					  &string[6]);
		    }
		  if (strstr (string, "su_ ") != NULL)
		    {
		      string[strlen (string) - 1] = '\0';
		      gtk_entry_set_text (GTK_ENTRY (pdata->entry_set_su),
					  &string[4]);
		    }
		  if (strstr (string, "sudo_ ") != NULL)
		    {
		      string[strlen (string) - 1] = '\0';
		      gtk_entry_set_text (GTK_ENTRY (pdata->entry_set_sudo),
					  &string[6]);
		    }
		  if (strstr (string, "ifacewifi ") != NULL)
		    {
		      string[strlen (string) - 1] = '\0';
		      gtk_entry_set_text (GTK_ENTRY (pdata->entry_set_inter),
					  &string[10]);
		      strcpy (pdata->interface, &string[10]);
		    }
		  if (strstr (string, "wpa_supp ") != NULL)
		    {
		      string[strlen (string) - 1] = '\0';
		      gtk_entry_set_text (GTK_ENTRY
					  (pdata->entry_set_wpa_supp),
					  &string[9]);
		    }
		  if (strstr (string, "wpa_cli ") != NULL)
		    {
		      string[strlen (string) - 1] = '\0';
		      gtk_entry_set_text (GTK_ENTRY
					  (pdata->entry_set_wpa_cli),
					  &string[8]);
		    }
		  if (strstr (string, "wpa_pas ") != NULL)
		    {
		      string[strlen (string) - 1] = '\0';
		      gtk_entry_set_text (GTK_ENTRY
					  (pdata->entry_set_wpa_pas),
					  &string[8]);
		    }

		  if (strstr (string, "wpa_ctrl ") != NULL)
		    {
		      string[strlen (string) - 1] = '\0';
		      gtk_entry_set_text (GTK_ENTRY
					  (pdata->entry_set_wpa_ctrl),
					  &string[9]);
		    }
		  if (strstr (string, "wpa_cfg ") != NULL)
		    {
		      string[strlen (string) - 1] = '\0';
		      gtk_entry_set_text (GTK_ENTRY
					  (pdata->entry_set_wpa_cfg),
					  &string[8]);
		    }

		  if (strstr (string, "wpadriver ") != NULL)
		    {
		      string[strlen (string) - 1] = '\0';
		      set_combo_entry_taxt (GTK_COMBO_BOX
					    (pdata->comboboxentry_wpa_ctrl),
					    &string[10]);
		    }
		  if (strstr (string, "checksys ") != NULL)
		    {
		      gtk_toggle_button_set_active (GTK_TOGGLE_BUTTON
						    (pdata->checkbutton1),
						    TRUE);
		    }
		  if (strstr (string, "checkvisible ") != NULL)
		    {
		      gtk_toggle_button_set_active (GTK_TOGGLE_BUTTON
						    (pdata->checkbutton3),
						    TRUE);
		    }
		  if (strstr (string, "checksudo ") != NULL)
		    {
		      gtk_toggle_button_set_active (GTK_TOGGLE_BUTTON
						    (pdata->checkbutton4),
						    TRUE);
		    }
		  if (strstr (string, "checkSU ") != NULL)
		    {
		      gtk_toggle_button_set_active (GTK_TOGGLE_BUTTON
						    (pdata->checkbutton11),
						    TRUE);
		    }
		  if (strstr (string, "checksimple ") != NULL)
		    {
		      gtk_toggle_button_set_active (GTK_TOGGLE_BUTTON
						    (pdata->checkbutton8),
						    TRUE);
		    }
		  if (strstr (string, "savepass ") != NULL)
		    {
		      gtk_toggle_button_set_active (GTK_TOGGLE_BUTTON
						    (pdata->checkbutton9),
						    TRUE);
		      string[strlen (string) - 1] = '\0';
		      strcpy (pdata->cryptpas, &string[9]);
		    }
		  if (strstr (string, "lowtray ") != NULL)
		    {
		      gtk_spin_button_set_value (GTK_SPIN_BUTTON
						 (pdata->spinbutton1),
						 atoi (&string[8]));
		    }
		  if (strstr (string, "mediumtray ") != NULL)
		    {
		      gtk_spin_button_set_value (GTK_SPIN_BUTTON
						 (pdata->spinbutton5),
						 atoi (&string[11]));
		    }
		  if (strstr (string, "hightray ") != NULL)
		    {
		      gtk_spin_button_set_value (GTK_SPIN_BUTTON
						 (pdata->spinbutton2),
						 atoi (&string[9]));
		    }
		  if (strstr (string, "maxsignal ") != NULL)
		    {
		      gtk_spin_button_set_value (GTK_SPIN_BUTTON
						 (pdata->spinbutton3),
						 atoi (&string[10]));
		    }
		  if (strstr (string, "timescan ") != NULL)
		    {
		      gtk_spin_button_set_value (GTK_SPIN_BUTTON
						 (pdata->entry_set_timescan),
						 atoi (&string[9]));
		    }
		  if (strstr (string, "timecon ") != NULL)
		    {
		      gtk_spin_button_set_value (GTK_SPIN_BUTTON
						 (pdata->
						  entry_set_time_to_con),
						 atoi (&string[8]));
		    }
		  if (strstr (string, "timecheck ") != NULL)
		    {
		      gtk_spin_button_set_value (GTK_SPIN_BUTTON
						 (pdata->
						  entry_set_time_to_con1),
						 atoi (&string[10]));
		    }
		  if (strstr (string, "wpamode auto") != NULL)
		    {
		      gtk_combo_box_set_active (GTK_COMBO_BOX
						(pdata->
						 comboboxentry_wpa_mode), 0);
		    }
		  if (strstr (string, "wpamode wpasupplicant") != NULL)
		    {
		      gtk_combo_box_set_active (GTK_COMBO_BOX
						(pdata->
						 comboboxentry_wpa_mode), 1);
		    }
		  if (strstr (string, "wpamode iwpriv-ralink") != NULL)
		    {
		      gtk_combo_box_set_active (GTK_COMBO_BOX
						(pdata->
						 comboboxentry_wpa_mode), 2);
		    }
		}
	    }
	}
      else
	break;
    }
  if (gtk_toggle_button_get_active (GTK_TOGGLE_BUTTON (pdata->checkbutton3)))
    {
    }
  else
    {
      gtk_widget_show (pdata->window);
    }
  fclose (fd);
	gchar path[100],path1[100];
	strcpy(path,getenv("HOME"));
	strcpy(path1,getenv("HOME"));
	strcat(path,"/.config/autostart/");
	strcat(path1,"/.kde/Autostart/");
  if(ls(path,"GwifiMeter.desktop")>0||ls(path1,"GwifiMeter.desktop")>0)
		gtk_toggle_button_set_active (GTK_TOGGLE_BUTTON
						    (pdata->checkbutton10),
						    TRUE);
}

//======================================================================
void
defaultset (void)
{
  gtk_entry_set_text (GTK_ENTRY (pdata->entry_set_iwconfig),
		      "/sbin/iwconfig");
  gtk_entry_set_text (GTK_ENTRY (pdata->entry_set_iwlist), "/sbin/iwlist");
  gtk_entry_set_text (GTK_ENTRY (pdata->entry_set_iwpriv), "iwpriv");
  gtk_entry_set_text (GTK_ENTRY (pdata->entry_set_dhcp), "dhclient");
//gtk_entry_set_text (GTK_ENTRY (pdata->entry_set_timescan),"5");
  gtk_entry_set_text (GTK_ENTRY (pdata->entry_set_inter), "auto");
  gtk_entry_set_text (GTK_ENTRY (pdata->entry_set_wpa_supp),
		      "wpa_supplicant");
  gtk_combo_box_set_active (GTK_COMBO_BOX (pdata->comboboxentry_theme), 0);
  gtk_entry_set_text (GTK_ENTRY (pdata->entry_set_ifconfig), "ifconfig");
  gtk_entry_set_text (GTK_ENTRY (pdata->entry_set_route), "route");
  gtk_entry_set_text (GTK_ENTRY (pdata->entry_set_su), "/bin/su");
  gtk_entry_set_text (GTK_ENTRY (pdata->entry_set_sudo), "/usr/bin/sudo");
//gtk_combo_box_set_active (GTK_COMBO_BOX (pdata->comboboxentry_lang),0);
  gtk_entry_set_text (GTK_ENTRY (pdata->entry_set_wpa_cli), "wpa_cli");
  gtk_combo_box_set_active (GTK_COMBO_BOX (pdata->comboboxentry_icon), 0);
  gtk_entry_set_text (GTK_ENTRY (pdata->entry_set_wpa_pas), "wpa_passphrase");
  gtk_entry_set_text (GTK_ENTRY (pdata->entry_set_wpa_ctrl),
		      "/var/run/wpa_supplicant");
  gtk_entry_set_text (GTK_ENTRY (pdata->entry_set_wpa_cfg),
		      "/tmp/wifi_config.cfg");
  gtk_toggle_button_set_active (GTK_TOGGLE_BUTTON (pdata->checkbutton1),
				TRUE);
  set_combo_entry_taxt (GTK_COMBO_BOX (pdata->comboboxentry_wpa_ctrl),
			"wext");
  gtk_toggle_button_set_active (GTK_TOGGLE_BUTTON (pdata->checkbutton9),
				FALSE);
  gtk_toggle_button_set_active (GTK_TOGGLE_BUTTON (pdata->checkbutton10),
				FALSE);
  gtk_toggle_button_set_active (GTK_TOGGLE_BUTTON (pdata->checkbutton8),
				FALSE);
  gtk_toggle_button_set_active (GTK_TOGGLE_BUTTON (pdata->checkbutton11),
				TRUE);
  gtk_spin_button_set_value (GTK_SPIN_BUTTON (pdata->spinbutton1), 30);
  gtk_spin_button_set_value (GTK_SPIN_BUTTON (pdata->spinbutton5), 50);
  gtk_spin_button_set_value (GTK_SPIN_BUTTON (pdata->spinbutton2), 70);
  gtk_spin_button_set_value (GTK_SPIN_BUTTON (pdata->spinbutton3), 70);
  gtk_spin_button_set_value (GTK_SPIN_BUTTON (pdata->entry_set_timescan), 5);
  gtk_spin_button_set_value (GTK_SPIN_BUTTON (pdata->entry_set_time_to_con),
			     15);
  gtk_spin_button_set_value (GTK_SPIN_BUTTON (pdata->entry_set_time_to_con1),
			     5);
//    set_combo_entry_taxt (GTK_COMBO_BOX (pdata->comboboxentry_wpa_mode) , "auto" );
  gtk_combo_box_set_active (GTK_COMBO_BOX (pdata->comboboxentry_wpa_mode), 0);
}

//=======================================================================
void
savepass (void)
{
  if (gtk_toggle_button_get_active (GTK_TOGGLE_BUTTON (pdata->checkbutton9)))
    pdata->setpas = passave ();
  else
    saveset (NULL);
}

void
saveset (GtkWidget * entry)
{
  char *profil3;

  profil3 = (char *) g_malloc (1500);

  strcpy (profil3, "iwconfig ");
  strcat (profil3,
	  gtk_entry_get_text (GTK_ENTRY (pdata->entry_set_iwconfig)));
  strcat (profil3, "\n");
  strcat (profil3, "iwlist ");
  strcat (profil3, gtk_entry_get_text (GTK_ENTRY (pdata->entry_set_iwlist)));
  strcat (profil3, "\n");
  strcat (profil3, "iwpriv ");
  strcat (profil3, gtk_entry_get_text (GTK_ENTRY (pdata->entry_set_iwpriv)));
  strcat (profil3, "\n");
  strcat (profil3, "dhcpclient ");
  strcat (profil3, gtk_entry_get_text (GTK_ENTRY (pdata->entry_set_dhcp)));
  strcat (profil3, "\n");
  strcat (profil3, "su_ ");
  strcat (profil3, gtk_entry_get_text (GTK_ENTRY (pdata->entry_set_su)));
  strcat (profil3, "\n");
  strcat (profil3, "sudo_ ");
  strcat (profil3, gtk_entry_get_text (GTK_ENTRY (pdata->entry_set_sudo)));
  strcat (profil3, "\n");
  strcat (profil3, "wpa_supp ");
  strcat (profil3,
	  gtk_entry_get_text (GTK_ENTRY (pdata->entry_set_wpa_supp)));
  strcat (profil3, "\n");
  strcat (profil3, "wpa_cli ");
  strcat (profil3, gtk_entry_get_text (GTK_ENTRY (pdata->entry_set_wpa_cli)));
  strcat (profil3, "\n");
  strcat (profil3, "wpa_pas ");
  strcat (profil3, gtk_entry_get_text (GTK_ENTRY (pdata->entry_set_wpa_pas)));
  strcat (profil3, "\n");
  strcat (profil3, "wpa_ctrl ");
  strcat (profil3,
	  gtk_entry_get_text (GTK_ENTRY (pdata->entry_set_wpa_ctrl)));
  strcat (profil3, "\n");
  strcat (profil3, "wpa_cfg ");
  strcat (profil3, gtk_entry_get_text (GTK_ENTRY (pdata->entry_set_wpa_cfg)));
  strcat (profil3, "\n");
  strcat (profil3, "ifacewifi ");
  strcat (profil3, gtk_entry_get_text (GTK_ENTRY (pdata->entry_set_inter)));
  strcat (profil3, "\n");
  strcat (profil3, "themes ");
  strcat (profil3,
	  gtk_combo_box_get_active_text (GTK_COMBO_BOX
					 (pdata->comboboxentry_theme)));
  strcat (profil3, "\n");
  strcat (profil3, "ifconfig ");
  strcat (profil3,
	  gtk_entry_get_text (GTK_ENTRY (pdata->entry_set_ifconfig)));
  strcat (profil3, "\n");
  strcat (profil3, "route ");
  strcat (profil3, gtk_entry_get_text (GTK_ENTRY (pdata->entry_set_route)));
  strcat (profil3, "\n");
//strcat(profil3,"language ");strcat(profil3,gtk_combo_box_get_active_text (GTK_COMBO_BOX (pdata->comboboxentry_lang)));strcat(profil3,"\n");
  strcat (profil3, "diricon ");
  strcat (profil3,
	  gtk_combo_box_get_active_text (GTK_COMBO_BOX
					 (pdata->comboboxentry_icon)));
  strcat (profil3, "\n");
  strcat (profil3, "wpadriver ");
  strcat (profil3,
	  gtk_combo_box_get_active_text (GTK_COMBO_BOX
					 (pdata->comboboxentry_wpa_ctrl)));
  strcat (profil3, "\n");

  if (gtk_toggle_button_get_active (GTK_TOGGLE_BUTTON (pdata->checkbutton1)))
    strcat (profil3, "checksys on\n");
// if (gtk_toggle_button_get_active (GTK_TOGGLE_BUTTON (pdata->checkbutton2)))strcat(profil3,"checkcolor on\n");
  if (gtk_toggle_button_get_active (GTK_TOGGLE_BUTTON (pdata->checkbutton3)))
    strcat (profil3, "checkvisible on\n");
// if (gtk_toggle_button_get_active (GTK_TOGGLE_BUTTON (pdata->checkbutton4)))strcat(profil3,"checkcommit on\n");
  if (gtk_toggle_button_get_active (GTK_TOGGLE_BUTTON (pdata->checkbutton4)))
    strcat (profil3, "checksudo on\n");
  if (gtk_toggle_button_get_active (GTK_TOGGLE_BUTTON (pdata->checkbutton8)))
    strcat (profil3, "checksimple on\n");
  if (gtk_toggle_button_get_active (GTK_TOGGLE_BUTTON (pdata->checkbutton11)))
    strcat (profil3, "checkSU on\n");
  if (gtk_toggle_button_get_active (GTK_TOGGLE_BUTTON (pdata->checkbutton9))
      && entry != NULL)
    {
      gchar *passs = pasave (gtk_entry_get_text (GTK_ENTRY (entry)));
      strcat (profil3, "savepass ");
      strcat (profil3, passs);
      strcat (profil3, "\n");
      g_free(passs);
    }
  if (pdata->setpas)
    gtk_widget_destroy (pdata->setpas);
  switch (gtk_combo_box_get_active
	  (GTK_COMBO_BOX (pdata->comboboxentry_wpa_mode)))
    {
    case 0:
      strcat (profil3, "wpamode auto\n");
      break;
    case 1:
      strcat (profil3, "wpamode wpasupplicant\n");
      break;
    case 2:
      strcat (profil3, "wpamode iwpriv-ralink\n");
      break;
    }
  char *buf;
  buf = (char *) g_malloc (100);
  sprintf (buf, "lowtray %d\n",
	   (int)
	   gtk_spin_button_get_value (GTK_SPIN_BUTTON (pdata->spinbutton1)));
  strcat (profil3, buf);
  sprintf (buf, "mediumtray %d\n",
	   (int)
	   gtk_spin_button_get_value (GTK_SPIN_BUTTON (pdata->spinbutton5)));
  strcat (profil3, buf);
  sprintf (buf, "hightray %d\n",
	   (int)
	   gtk_spin_button_get_value (GTK_SPIN_BUTTON (pdata->spinbutton2)));
  strcat (profil3, buf);
  sprintf (buf, "maxsignal %d\n",
	   (int)
	   gtk_spin_button_get_value (GTK_SPIN_BUTTON (pdata->spinbutton3)));
  strcat (profil3, buf);
  sprintf (buf, "timescan %d\n",
	   (int)
	   gtk_spin_button_get_value (GTK_SPIN_BUTTON
				      (pdata->entry_set_timescan)));
  strcat (profil3, buf);
  sprintf (buf, "timecon %d\n",
	   (int)
	   gtk_spin_button_get_value (GTK_SPIN_BUTTON
				      (pdata->entry_set_time_to_con)));
  strcat (profil3, buf);
  sprintf (buf, "timecheck %d\n",
	   (int)
	   gtk_spin_button_get_value (GTK_SPIN_BUTTON
				      (pdata->entry_set_time_to_con1)));
  strcat (profil3, buf);
  g_free (buf);
  int file;
  char *tab2, *tab4, *profil1;
  int co1;
  file = open (pdata->user, O_RDONLY | O_CREAT, S_IRUSR | S_IWUSR);
  if (file > 0)
    {
      tab4 = (char *) g_malloc (1);

      if (pdata->user == 0)
	printf ("virtual memory exceeded\n");
      tab2 = (char *) g_malloc (1);

      if (tab2 == 0)
	printf ("virtual memory exceeded\n");
//*(pdata->user)='\0';
      *tab2 = '\0';
      bzero (tab4, sizeof (tab4));
      while (1)
	{
	  co1 = read (file, tab2 =
		      (char *) g_realloc (tab2, sizeof (tab2) + 1),
		      sizeof (tab2));
	  if (co1 == 0)
	    {
	      close (file);
	      break;
	    }

	  tab4 = g_realloc (tab4, strlen (tab4) + sizeof (tab2) + 1);
	  strncat (tab4, tab2, sizeof (tab2));
	  bzero (tab2, sizeof (tab2));
	}
      g_free (tab2);
//write(1,tab4,strlen(tab4));
      profil1 = strstr (tab4, "PROFIL ");
      if (profil1 != NULL)
	{
//printf("kopiuje profil\n");
	  profil3 =
	    (char *) g_realloc (profil3,
				strlen (profil3) + strlen (profil1) + 1);
	  strcat (profil3, profil1);
	  g_free (tab4);
	}
    }
  else
    printf ("blad otwarcia pliku \n");
  file = open (pdata->user, O_WRONLY | O_CREAT | O_TRUNC, S_IRUSR | S_IWUSR);
  if (file > 0)
    {
      write (file, profil3, strlen (profil3));
      close (file);
    }
  g_free (profil3);
if (gtk_toggle_button_get_active (GTK_TOGGLE_BUTTON (pdata->checkbutton10)))
		addstartup(TRUE);
	else
		addstartup(FALSE);
}

//===========================================================
int
langappend (char *path, char *def, GtkComboBox * combo_box)
{
  struct dirent **namelist;
  int n, s = 1;
  n = scandir (path, &namelist, 0, alphasort);
  //perror("scandir");
  if (n > 2)
    {
      while (2 < n--)
	{
	  gtk_combo_box_append_text (combo_box, (namelist[n]->d_name));
	  //printf("%s\n", namelist[n]->d_name);
	  free (namelist[n]);
	  if (strstr (def, namelist[n]->d_name) != 0)
	    gtk_combo_box_set_active (combo_box, s);
	  ++s;
	}
      free (namelist);
      return n;
    }
  else
    {
      return -1;
    }
}
//===========================================================
int ls(gchar * path,gchar * tagret)
{
    struct dirent **namelist;
    int n,s=0;
    n = scandir(path, &namelist, 0, alphasort);
    if (n < 0)
        perror("scandir");
    else {
        while(n--) {
			if(strstr(namelist[n]->d_name,tagret)!=0)s=1;
			//printf("%s %s %d\n", namelist[n]->d_name,tagret,s);
            free(namelist[n]);
        }
        free(namelist);
    }
	return s;
}
void addstartup(gboolean is_active)
{
if(is_active)
	{
	gchar path[100];
	strcpy(path,getenv("HOME"));		
  if(ls(path,".config")>0)
		{
			strcat(path,"/.config/");
			if(ls(path,"autostart")==0)
			{
				strcat(path,"autostart");
				mkdir(path, S_IRWXU | S_IRWXG | S_IROTH | S_IXOTH);
			}
			strcat(path,"/GwifiMeter.desktop");
		    FILE *fd;
			fd = fopen (path, "w");
		    if (fd != NULL)
		    {
			fprintf(fd,"\n[Desktop Entry]\nType=Application\nEncoding=UTF-8\nVersion=1.0\nName=GwifiMeter\nExec=GwifiMeter\nX-GNOME-Autostart-enabled=true\n");
			fclose(fd);
			}else printf ("\n error opening file %s\n",path);		
		}else printf ("\n error opening path for GNOME %s\n",path);
		

	strcpy(path,getenv("HOME"));
  if(ls(path,".kde")>0)
		{
			strcat(path,"/.kde/");
			if(ls(path,"Autostart")==0)
			{
				strcat(path,"Autostart");
				mkdir(path, S_IRWXU | S_IRWXG | S_IROTH | S_IXOTH);
			}
			strcat(path,"/GwifiMeter.desktop");
		    FILE *fd;
			fd = fopen (path, "w");
		    if (fd != NULL)
		    {
			fprintf(fd,"\n[Desktop Entry]\nType=Application\nEncoding=UTF-8\nVersion=1.0\nName=GwifiMeter\nExec=GwifiMeter\nX-GNOME-Autostart-enabled=true\n");
			fclose(fd);
			}else printf ("\n error opening file %s\n",path);		
		}else printf ("\n error opening path for KDE %s\n",path);
	}
	else
	{
		gchar path[100];
		strcpy(path,getenv("HOME"));
		strcat(path,"/.config/autostart/GwifiMeter.desktop");
		if(remove(path)!=0)printf("cant remove file %s\n",path);
		strcpy(path,getenv("HOME"));
		strcat(path,"/.kde/Autostart/GwifiMeter.desktop");
		if(remove(path)!=0)printf("cant remove file %s\n",path);
	}
}
